<?php
/**
 * The Template for displaying the individual website comment controls.
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/admin/website/website-comment-controls.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     3.0.0
 */
?>

<script type="text/html" id="tmpl-comment-item-controls">
	<i class="ph-icon ph-edit ion-android-create"></i>
	<i class="ph-icon ph-remove ion-trash-b" data-confirm="<?php esc_html_e( 'Are you sure you want to delete this comment?', 'project-huddle' ); ?>"></i>
</script>