<?php
/**
 * The Template for displaying the individual website comment text
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/admin/website/website-comment-text.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     3.0.0
 */
?>

<script type="text/html" id="tmpl-comment-item-text">
	<div class="ph-comment-item-content">
		<# if ( data.content && data.content.rendered ) { #>
		{{{ data.content.rendered }}}
		<# } else { #>
		{{{ data.content }}}
		<# } #>
		<?php do_action( 'ph_comment_item_after_text', get_the_ID() ); ?>
	</div>
</script>