<?php
/**
 * The Template for displaying the website page edit view
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/admin/website/website-page-title-edit.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     3.0.0
 */
?>

<script type="text/html" id="tmpl-edit-webpage-title">
	<input class="ph-edit-content" value="{{{ data.title.rendered }}}" /><br>
	<button class="button button-primary ph-edit-save"><?php esc_html_e( 'Save', 'project-huddle' ); ?></button>
	<button class="button button-secondary ph-edit-cancel"><?php esc_html_e( 'Cancel', 'project-huddle' ); ?></button>
</script>