<?php
/**
 * The Template for displaying the website page container
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/admin/website/website-page.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     3.0.0
 */
?>

<script type="text/template" id="tmpl-website-page">
	<div class="ph-webpage-header">
		<h4 class="ph-webpage-title"></h4>
		<a href="#" class="ph-toggle-indicator ph-toggle-page">
			<span class="ion-minus"></span>
			<span class="ion-plus"></span>
		</a>
	</div>
	<div class="ph-webpage-tasks-container"></div>
	<div class="ph-comment-counter ph-placeholder ph-toggle-page"><span>{{ data.comment_count }} <?php esc_html_e( 'Comments', 'project-huddle' ); ?></span></div>
</script>