<?php global $post; ?>
<!-- Panel Container  -->

<script type="text/html" id='tmpl-ph-panel-css'>
	<?php
    // create iframe
    $file = PH_PLUGIN_DIR . 'assets/css/dist/ph-website-panel.css';

    if (file_exists($file)) {
        readfile($file);
    }
	?>
	<?php echo ph_website_style_options(); ?>
</script>
<script type="text/html" id='tmpl-ph-panel'>
	<div class="ph-panel-inner">
		<div class="ph-panel-header-wrap has-shadow dark">
			<div class="ph-panel-header">
				<i class="ph-icon ion-android-close ph-close" title="<?php _e( 'Close Sidebar', 'project-huddle' ); ?>">
					<svg viewBox="0 0 512 512" id="ion-close" width="12" height="12"><path d="M443.6 387.1L312.4 255.4l131.5-130c5.4-5.4 5.4-14.2 0-19.6l-37.4-37.6c-2.6-2.6-6.1-4-9.8-4-3.7 0-7.2 1.5-9.8 4L256 197.8 124.9 68.3c-2.6-2.6-6.1-4-9.8-4-3.7 0-7.2 1.5-9.8 4L68 105.9c-5.4 5.4-5.4 14.2 0 19.6l131.5 130L68.4 387.1c-2.6 2.6-4.1 6.1-4.1 9.8 0 3.7 1.4 7.2 4.1 9.8l37.4 37.6c2.7 2.7 6.2 4.1 9.8 4.1 3.5 0 7.1-1.3 9.8-4.1L256 313.1l130.7 131.1c2.7 2.7 6.2 4.1 9.8 4.1 3.5 0 7.1-1.3 9.8-4.1l37.4-37.6c2.6-2.6 4.1-6.1 4.1-9.8-.1-3.6-1.6-7.1-4.2-9.7z"></path></svg>
				</i>

				<?php if ( $logo = apply_filters( 'ph_website_control_logo_id', get_option( 'ph_website_control_logo' ) ) ) : ?>
					<div class="ph-panel-title-item ph-panel-logo-wrap">
						<div class="ph-panel-logo">
							<?php
							// get logo image
							$logo_image = wp_get_attachment_image_src( $logo, 'full' );

							// check retina option
							if ( apply_filters( 'ph_website_control_logo_retina', get_option( 'ph_website_control_logo_retina' ) ) ) :
								$logo_image[1] = $logo_image[1] / 2;
								$logo_image[2] = $logo_image[2] / 2;
							endif;
							?>

							<a href="<?php echo apply_filters( 'ph_website_logo_url', home_url() ); ?>">
								<img src="<?php echo esc_url( $logo_image[0] ); ?>" width="<?php echo (float) $logo_image[1]; ?>" height="<?php echo (float) $logo_image[2]; ?>"/>
							</a>

						</div>
					</div>
				<?php endif; ?>

				<div class="ph-panel-title-item">
					<div class="ph-tab ph-active ph-comments-tab">
						<?php _e( 'Comments', 'project-huddle' ); ?>
					</div>
					<div class="ph-tab ph-pages-tab">
						<?php _e( 'Pages', 'project-huddle' ); ?>
					</div>
				</div>
			</div>
		</div>
		<div class="ph-panel-subheading ph-show-comments ph-active"></div>
		<div class="ph-panel-body">
			<div class="ph-panel-tab-content ph-panel-comments-list ph-comments-tab ph-active"></div>
			<div class="ph-panel-tab-content ph-pages-tab ph-panel-pages-list"></div>
		</div>
		<div class="ph-panel-footer">
            <div class="left-col"></div>
            <div class="middle-col"></div>
            <div class="right-col"></div>
        </div>
	</div>
</script>
<!-- Panel Container -->

<!-- manage project button -->
<script type="text/html" id="tmpl-ph-manage-button">
    <a href="{{{ data.edit_link }}}" target="_blank" class="ph-icon">
    <i class="ion-android-settings" title="<?php _e( 'Manage', 'project-huddle' ); ?>">
            <svg viewBox="0 0 512 512" id="ion-android-settings" width="12" height="12"><path d="M413.967 276.8c1.06-6.235 1.06-13.518 1.06-20.8s-1.06-13.518-1.06-20.8l44.667-34.318c4.26-3.118 5.319-8.317 2.13-13.518L418.215 115.6c-2.129-4.164-8.507-6.235-12.767-4.164l-53.186 20.801c-10.638-8.318-23.394-15.601-36.16-20.801l-7.448-55.117c-1.06-4.154-5.319-8.318-10.638-8.318h-85.098c-5.318 0-9.577 4.164-10.637 8.318l-8.508 55.117c-12.767 5.2-24.464 12.482-36.171 20.801l-53.186-20.801c-5.319-2.071-10.638 0-12.767 4.164L49.1 187.365c-2.119 4.153-1.061 10.399 2.129 13.518L96.97 235.2c0 7.282-1.06 13.518-1.06 20.8s1.06 13.518 1.06 20.8l-44.668 34.318c-4.26 3.118-5.318 8.317-2.13 13.518L92.721 396.4c2.13 4.164 8.508 6.235 12.767 4.164l53.187-20.801c10.637 8.318 23.394 15.601 36.16 20.801l8.508 55.117c1.069 5.2 5.318 8.318 10.637 8.318h85.098c5.319 0 9.578-4.164 10.638-8.318l8.518-55.117c12.757-5.2 24.464-12.482 36.16-20.801l53.187 20.801c5.318 2.071 10.637 0 12.767-4.164l42.549-71.765c2.129-4.153 1.06-10.399-2.13-13.518l-46.8-34.317zm-158.499 52c-41.489 0-74.46-32.235-74.46-72.8s32.971-72.8 74.46-72.8 74.461 32.235 74.461 72.8-32.972 72.8-74.461 72.8z"></path></svg>
        </i>
		<?php _e( 'Manage', 'project-huddle' ); ?>
    </a>
</script>

<!-- logout button -->
<script type="text/html" id="tmpl-ph-logout-button">
    <a href="<?php echo wp_logout_url( get_post_meta( $post->ID, 'website_url', true ) ); ?>" target="_parent" class="ph-icon">
        <i class="ion-log-out" title="<?php _e( 'Logout', 'project-huddle' ); ?>">
            <svg viewBox="0 0 512 512" id="ion-log-out" width="10" height="10"><path d="M366.863 323.883l22.627 22.627L480 256l-90.51-90.51-22.628 22.628L418.745 240H192v32h226.745z"></path><path d="M391.491 391.766C355.229 428.029 307.018 448 255.736 448c-51.287 0-99.506-19.971-135.772-56.235C83.697 355.501 64 307.285 64 256c0-51.281 19.697-99.495 55.965-135.761C156.232 83.973 204.45 64 255.736 64c51.279 0 99.491 19.973 135.755 56.238a196.044 196.044 0 0 1 7.333 7.762h40.731c-40.474-58.028-107.709-96-183.819-96C132.021 32 32 132.298 32 256c0 123.715 100.021 224 223.736 224 76.112 0 143.35-37.97 183.822-96h-40.73a194.792 194.792 0 0 1-7.337 7.766z"></path></svg>
        </i>
		<?php _e( 'Logout', 'project-huddle' ); ?>
    </a>
</script>

<!-- logout button -->
<script type="text/html" id="tmpl-ph-login-button">
    <a href="<?php echo wp_login_url( get_post_meta( $post->ID, 'website_url', true ) ); ?>" target="_parent" class="ph-icon">
        <i class="ion-log-out" title="<?php _e( 'Login', 'project-huddle' ); ?>">
            <svg viewBox="0 0 512 512" id="ion-log-out" width="10" height="10"><path d="M366.863 323.883l22.627 22.627L480 256l-90.51-90.51-22.628 22.628L418.745 240H192v32h226.745z"></path><path d="M391.491 391.766C355.229 428.029 307.018 448 255.736 448c-51.287 0-99.506-19.971-135.772-56.235C83.697 355.501 64 307.285 64 256c0-51.281 19.697-99.495 55.965-135.761C156.232 83.973 204.45 64 255.736 64c51.279 0 99.491 19.973 135.755 56.238a196.044 196.044 0 0 1 7.333 7.762h40.731c-40.474-58.028-107.709-96-183.819-96C132.021 32 32 132.298 32 256c0 123.715 100.021 224 223.736 224 76.112 0 143.35-37.97 183.822-96h-40.73a194.792 194.792 0 0 1-7.337 7.766z"></path></svg>
        </i>
		<?php _e( 'Login', 'project-huddle' ); ?>
    </a>
</script>

<!-- help button -->
<script type="text/html" id="tmpl-ph-help-button">
	<?php if ( $link = get_option( 'ph_help_link', '' ) ) : ?>
        <a href="<?php echo esc_url( $link ); ?>" target="_blank" class="ph-icon">
            <i class="ion-help-circled" title="<?php _e( 'Help', 'project-huddle' ); ?>">
                <svg viewBox="0 0 512 512" id="ion-help-circled" width="10" height="10"><path d="M256 32C132.3 32 32 132.3 32 256s100.3 224 224 224 224-100.3 224-224S379.7 32 256 32zm20.2 326.7c-.5 17.8-13.7 28.8-30.8 28.3-16.4-.5-29.3-12.2-28.8-30.1.5-17.8 14.1-29.1 30.5-28.6 17.2.5 29.7 12.6 29.1 30.4zm48.7-127.3c-4.2 5.9-13.6 13.5-25.4 22.7l-13.1 9c-6.4 4.9-10.4 10.7-12.5 17.3-1.1 3.5-1.9 12.6-2.1 18.7-.1 1.2-.8 3.9-4.5 3.9h-39.1c-4.1 0-4.6-2.4-4.5-3.6.6-16.6 3-30.3 9.9-41.3 9.3-14.8 35.5-30.4 35.5-30.4 4-3 7.1-6.2 9.5-9.7 4.4-6 8-12.7 8-19.9 0-8.3-2-16.2-7.3-22.8-6.2-7.7-12.9-11.4-25.8-11.4-12.7 0-20.1 6.4-25.4 14.8-5.3 8.4-4.4 18.3-4.4 27.3H175c0-34 8.9-55.7 27.7-68.5 12.7-8.7 28.9-12.5 47.8-12.5 24.8 0 44.5 4.6 61.9 17.8 16.1 12.2 24.6 29.4 24.6 52.6 0 14.3-5 26.3-12.1 36z"></path></svg>
            </i>
			<?php _e( 'Help', 'project-huddle' ); ?>
        </a>
	<?php endif; ?>
</script>

<script type="text/html" id='tmpl-ph-panel-empty-comments'>
	<?php _e('No Comments', 'project-huddle'); ?>
</script>
<script type="text/html" id='tmpl-ph-panel-empty-pages'>
	<?php _e('No Pages', 'project-huddle'); ?>
</script>

<!-- Panel Comment Item  -->
<script type="text/html" id='tmpl-ph-panel-item'>
	<div class="ph-comment-avatar ph-navigate">
		<div class="ph-avatar">
			<div class="avatar"></div>

			<div class="ph-comment-number<# if (data.resolved) { #> ph-approved<# } #>">
				{{ Number(data.order) + 1 }}
			</div>
		</div>

		<div class="ph-comment-item-date">
			{{ data.humanDate }}
		</div>
	</div>

	<div class="ph-comment-content">
		<div class="ph-comment-header">
			<div class="ph-comment-author ph-navigate">
                {{ data.author_name }}
			</div>
			<div class="ph-comment-header-left"></div>
			<div class="ph-comment-header-right"></div>
		</div>
		<div class="ph-comment-item-content ph-navigate">
			<# if ( data.content ) { #>
				{{{ data.content.rendered }}}
			<# } #>
		</div>
		<div class="ph-comment-item-details">
			<div class="ph-tooltip-wrap ph-navigate">
				<i class="ion-location">
                    <svg xmlns="http://www.w3.org/2000/svg" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-map-pin"><path d="M21 10c0 7-9 13-9 13s-9-6-9-13a9 9 0 0 1 18 0z"></path><circle cx="12" cy="10" r="3"></circle></svg>
                </i>
				<div class="ph-tooltip">
					<?php _e( 'View Location', 'project-huddle' ); ?>
					<i class="ion-arrow-right-c">
                        <svg xmlns="http://www.w3.org/2000/svg" width="10" height="10" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-arrow-right"><line x1="5" y1="12" x2="19" y2="12"></line><polyline points="12 5 19 12 12 19"></polyline></svg>
					</i>
				</div>
			</div>
			<div class="ph-tooltip-wrap">
                <# if (data.resX < 780 ) { #>
                    <i class="icon-phone">
                        <svg xmlns="http://www.w3.org/2000/svg" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-smartphone"><rect x="5" y="2" width="14" height="20" rx="2" ry="2"></rect><line x1="12" y1="18" x2="12" y2="18"></line></svg>
                    </i>
                <# } else if ( data.resX >= 480 && data.resX < 780 ) { #>
                    <i class="icon-tablet">
                        <svg xmlns="http://www.w3.org/2000/svg" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-tablet"><rect x="4" y="2" width="16" height="20" rx="2" ry="2" transform="rotate(180 12 12)"></rect><line x1="12" y1="18" x2="12" y2="18"></line></svg>
                    </i>
                <# } else if ( data.resX >= 780 ) { #>
                    <i class="ion-android-desktop">
                        <svg xmlns="http://www.w3.org/2000/svg" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-monitor"><rect x="2" y="3" width="20" height="14" rx="2" ry="2"></rect><line x1="8" y1="21" x2="16" y2="21"></line><line x1="12" y1="17" x2="12" y2="21"></line></svg>
                    </i>
                <# } #>
				<div class="ph-tooltip">
					{{ data.browser }} {{ data.browserVersion }} <br>
					{{ data.browserOS }}
				</div>
			</div>
			<div class="ph-tooltip-wrap">
                <i class="icon-resolution">
                    <svg xmlns="http://www.w3.org/2000/svg" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-maximize"><path d="M8 3H5a2 2 0 0 0-2 2v3m18 0V5a2 2 0 0 0-2-2h-3m0 18h3a2 2 0 0 0 2-2v-3M3 16v3a2 2 0 0 0 2 2h3"></path></svg>
                </i>
				<div class="ph-tooltip">
					{{ data.resX }} x {{ data.resY }}
				</div>
			</div>
			<div class="ph-tooltip-wrap ph-navigate" data-focus="true">
				<i class="icon-reply">
                    <svg xmlns="http://www.w3.org/2000/svg" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-corner-up-left"><polyline points="9 14 4 9 9 4"></polyline><path d="M20 20v-7a4 4 0 0 0-4-4H4"></path></svg>
                </i>
				<div class="ph-tooltip">
					<?php _e('Reply', 'project-huddle' ); ?>
					<i class="ion-arrow-right-c">
                        <svg xmlns="http://www.w3.org/2000/svg" width="10" height="10" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-arrow-right"><line x1="5" y1="12" x2="19" y2="12"></line><polyline points="12 5 19 12 12 19"></polyline></svg>
					</i>
				</div>
			</div>

			<div class="ph-comment-count ph-navigate<# if ( data.comments_count > 1 ) {#> has-comments<#}#> ph-tooltip-wrap">
				{{ data.comments_count - 1 }}
				<div class="ph-tooltip">
					<?php echo sprintf( _n( '%1s replies', '%1s replies', '{{ data.comments_count - 1 }}', 'project-huddle'), '{{ data.comments_count - 1 }}'); ?>
				</div>
			</div>
		</div>
	</div>
</script>

<!-- Panel Page Item -->
<script type="text/html" id='tmpl-ph-panel-page-item'>
	<# var percent = (data.resolved_count / data.comment_count ) * 100; #>
	<div class="ph-page-title">
		<a href="{{ data.page_url }}">{{{ data.title.rendered }}}</a>
	</div>
	<div class="ph-page-url">
		<a href="{{ data.page_url }}">
			<# var parsed = data.page_url.replace(/(^\w+:|^)\/\//, ''); #>
			{{ parsed }}
		</a>
	</div>
	<div class="ph-comment-progress-wrap <# if (percent >= 100) { #> ph-approved<# } #>">
		<div class="ph-page-comment-count">{{ data.comment_count }}</div>
		<div class="ph-approval-progress-bar-wrap ph-tooltip-wrap">
			<div class="ph-approval-progress-bar">
				<div class="ph-approval-progress" style="width:{{ percent }}%"></div>
				<div class="ph-tooltip">
					<?php echo sprintf( __('%1s of %2s resolved', 'project-huddle'), '{{ data.resolved_count }}', '{{ data.comment_count }}' ); ?>
				</div>
			</div>
		</div>
		<a  href="{{ data.page_url }}" class="ph-badge ph-visit-page-link">
			<?php _e( 'Visit Page', 'project-huddle' ); ?>
            <i class="icon-right">
                <svg xmlns="http://www.w3.org/2000/svg" width="10" height="10" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-arrow-right"><line x1="5" y1="12" x2="19" y2="12"></line><polyline points="12 5 19 12 12 19"></polyline></svg>
            </i>
		</a>
	</div>
</script>
<!-- Panel Page Item -->