<!-- Submit Button Template -->
<script type="text/template" id="tmpl-ph-comment-button">
	<button title="<?php _e('Add A New Comment', 'project-huddle'); ?>" class="ph-add-comment-text ph-button ph-make-comment">
		<i class="ph-icon">
            <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-plus"><line x1="12" y1="5" x2="12" y2="19"></line><line x1="5" y1="12" x2="19" y2="12"></line></svg>
		</i>
	</button>
	<button title="<?php _e('Cancel Comment', 'project-huddle'); ?>" class="ph-cancel-comment-text ph-button ph-make-comment">
		<i class="ph-icon">
            <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-x"><line x1="18" y1="6" x2="6" y2="18"></line><line x1="6" y1="6" x2="18" y2="18"></line></svg>
        </i>
	</button>
</script>
<!-- Submit Button Template -->

<!-- Submit Button Template -->
<script type="text/template" id="tmpl-ph-comment-icon">
	<i class="ph-icon ion-chatboxes" title="<?php _e('Click To See All Comments', 'project-huddle'); ?>">
        <svg xmlns="http://www.w3.org/2000/svg" width="22" height="22" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-message-square">
            <path d="M21 15a2 2 0 0 1-2 2H7l-4 4V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2z"></path>
        </svg>
        <span class="ph-comment-count">
			<# if ( data.show_resolved )  { #>
				{{ data.comment_count }}
			<# } else { #>
				{{ data.unresolved_count }}
			<# } #>
		</span>
	</i>
</script>
<!-- Submit Button Template -->