<?php
/**
 * The Website Toolbar Container
 *
 * @package     ProjectHuddle
 * @subpackage  ph-website-comments
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.2.0
 */
global $post;
?>

<script type="text/html" id='tmpl-ph-toolbar-css'>
	<?php
    // create iframe
    $file = PH_PLUGIN_DIR . 'assets/css/dist/ph-website-toolbar.css';

    if (file_exists($file)) {
        readfile($file);
    }
	?>
	<?php echo ph_website_style_options(); ?>
</script>
<script type="text/html" id='tmpl-ph-toolbar'>
	<div class="ph-move-control">
		<svg viewBox="0 0 512 512" id="ion-drag" class="ion-drag" width="14" height="14"><path d="M0 144h512v32H0zM0 240h512v32H0zM0 336h512v32H0z"></path></svg>
	</div>
	<div class="ph-controls"></div>
    <?php do_action( 'ph_after_website_toolbar_buttons' ); ?>
</script>

<script type="text/html" id="tmpl-ph-panel-status">
    <div class="ph-comment-status ph-badge status-{{ data.status_id }}">
        {{ data.status_name }} <i class="ion-chevron-down"></i>
    </div>
    <div class="ph-panel-status-select">
	    <?php
	    $stati = get_terms( apply_filters( 'ph_status_args', array(
		    'taxonomy'   => 'ph_status',
		    'hide_empty' => false,
	    ), get_the_ID() ) );
	    foreach( $stati as $status ) : ?>
            <div class="status-option" data-id="<?php echo (int)$status->term_id; ?>">
	            <?php echo esc_html( $status->name ); ?>
            </div>
	    <?php endforeach; ?>
    </div>
</script>