/*!
 Autosize 3.0.5
 license: MIT
 http://www.jacklmoore.com/autosize
 */
!function(e,t){if("function"==typeof define&&define.amd)define(["exports","module"],t);else if("undefined"!=typeof exports&&"undefined"!=typeof module)t(exports,module);else{var o={exports:{}};t(o.exports,o),e.autosize=o.exports}}(this,function(e,t){"use strict";function o(e){function t(){var t=window.getComputedStyle(e,null);"vertical"===t.resize?e.style.resize="none":"both"===t.resize&&(e.style.resize="horizontal"),l="content-box"===t.boxSizing?-(parseFloat(t.paddingTop)+parseFloat(t.paddingBottom)):parseFloat(t.borderTopWidth)+parseFloat(t.borderBottomWidth),n()}function o(t){var o=e.style.width;e.style.width="0px",e.offsetWidth,e.style.width=o,u=t,a&&(e.style.overflowY=t),n()}function n(){var t=e.style.height,n=document.documentElement.scrollTop,i=document.body.scrollTop,r=e.style.height;e.style.height="auto";var d=e.scrollHeight+l;if(0===e.scrollHeight)return void(e.style.height=r);e.style.height=d+"px",document.documentElement.scrollTop=n,document.body.scrollTop=i;var s=window.getComputedStyle(e,null);if(s.height!==e.style.height){if("visible"!==u)return void o("visible")}else if("hidden"!==u)return void o("hidden");if(t!==e.style.height){var a=document.createEvent("Event");a.initEvent("autosize:resized",!0,!1),e.dispatchEvent(a)}}var i=void 0===arguments[1]?{}:arguments[1],r=i.setOverflowX,d=void 0===r?!0:r,s=i.setOverflowY,a=void 0===s?!0:s;if(e&&e.nodeName&&"TEXTAREA"===e.nodeName&&!e.hasAttribute("data-autosize-on")){var l=null,u="hidden",v=function(t){window.removeEventListener("resize",n),e.removeEventListener("input",n),e.removeEventListener("keyup",n),e.removeAttribute("data-autosize-on"),e.removeEventListener("autosize:destroy",v),Object.keys(t).forEach(function(o){e.style[o]=t[o]})}.bind(e,{height:e.style.height,resize:e.style.resize,overflowY:e.style.overflowY,overflowX:e.style.overflowX,wordWrap:e.style.wordWrap});e.addEventListener("autosize:destroy",v),"onpropertychange"in e&&"oninput"in e&&e.addEventListener("keyup",n),window.addEventListener("resize",n),e.addEventListener("input",n),e.addEventListener("autosize:update",n),e.setAttribute("data-autosize-on",!0),a&&(e.style.overflowY="hidden"),d&&(e.style.overflowX="hidden",e.style.wordWrap="break-word"),t()}}function n(e){if(e&&e.nodeName&&"TEXTAREA"===e.nodeName){var t=document.createEvent("Event");t.initEvent("autosize:destroy",!0,!1),e.dispatchEvent(t)}}function i(e){if(e&&e.nodeName&&"TEXTAREA"===e.nodeName){var t=document.createEvent("Event");t.initEvent("autosize:update",!0,!1),e.dispatchEvent(t)}}var r=null;"undefined"==typeof window||"function"!=typeof window.getComputedStyle?(r=function(e){return e},r.destroy=function(e){return e},r.update=function(e){return e}):(r=function(e,t){return e&&Array.prototype.forEach.call(e.length?e:[e],function(e){return o(e,t)}),e},r.destroy=function(e){return e&&Array.prototype.forEach.call(e.length?e:[e],n),e},r.update=function(e){return e&&Array.prototype.forEach.call(e.length?e:[e],i),e}),t.exports=r});
( function( window, undefined ) {
	'use strict';

	/**
	 * Handles managing all events for whatever you plug it into. Priorities for hooks are based on lowest to highest in
	 * that, lowest priority hooks are fired first.
	 */
	var EventManager = function() {
		var slice = Array.prototype.slice;
		
		/**
		 * Maintain a reference to the object scope so our public methods never get confusing.
		 */
		var MethodsAvailable = {
			removeFilter : removeFilter,
			applyFilters : applyFilters,
			addFilter : addFilter,
			removeAction : removeAction,
			doAction : doAction,
			addAction : addAction
		};

		/**
		 * Contains the hooks that get registered with this EventManager. The array for storage utilizes a "flat"
		 * object literal such that looking up the hook utilizes the native object literal hash.
		 */
		var STORAGE = {
			actions : {},
			filters : {}
		};

		/**
		 * Adds an action to the event manager.
		 *
		 * @param action Must contain namespace.identifier
		 * @param callback Must be a valid callback function before this action is added
		 * @param [priority=10] Used to control when the function is executed in relation to other callbacks bound to the same hook
		 * @param [context] Supply a value to be used for this
		 */
		function addAction( action, callback, priority, context ) {
			if( typeof action === 'string' && typeof callback === 'function' ) {
				priority = parseInt( ( priority || 10 ), 10 );
				_addHook( 'actions', action, callback, priority, context );
			}

			return MethodsAvailable;
		}

		/**
		 * Performs an action if it exists. You can pass as many arguments as you want to this function; the only rule is
		 * that the first argument must always be the action.
		 */
		function doAction( /* action, arg1, arg2, ... */ ) {
			var args = slice.call( arguments );
			var action = args.shift();

			if( typeof action === 'string' ) {
				_runHook( 'actions', action, args );
			}

			return MethodsAvailable;
		}

		/**
		 * Removes the specified action if it contains a namespace.identifier & exists.
		 *
		 * @param action The action to remove
		 * @param [callback] Callback function to remove
		 */
		function removeAction( action, callback ) {
			if( typeof action === 'string' ) {
				_removeHook( 'actions', action, callback );
			}

			return MethodsAvailable;
		}

		/**
		 * Adds a filter to the event manager.
		 *
		 * @param filter Must contain namespace.identifier
		 * @param callback Must be a valid callback function before this action is added
		 * @param [priority=10] Used to control when the function is executed in relation to other callbacks bound to the same hook
		 * @param [context] Supply a value to be used for this
		 */
		function addFilter( filter, callback, priority, context ) {
			if( typeof filter === 'string' && typeof callback === 'function' ) {
				priority = parseInt( ( priority || 10 ), 10 );
				_addHook( 'filters', filter, callback, priority, context );
			}

			return MethodsAvailable;
		}

		/**
		 * Performs a filter if it exists. You should only ever pass 1 argument to be filtered. The only rule is that
		 * the first argument must always be the filter.
		 */
		function applyFilters( /* filter, filtered arg, arg2, ... */ ) {
			var args = slice.call( arguments );
			var filter = args.shift();

			if( typeof filter === 'string' ) {
				return _runHook( 'filters', filter, args );
			}

			return MethodsAvailable;
		}

		/**
		 * Removes the specified filter if it contains a namespace.identifier & exists.
		 *
		 * @param filter The action to remove
		 * @param [callback] Callback function to remove
		 */
		function removeFilter( filter, callback ) {
			if( typeof filter === 'string') {
				_removeHook( 'filters', filter, callback );
			}

			return MethodsAvailable;
		}

		/**
		 * Removes the specified hook by resetting the value of it.
		 *
		 * @param type Type of hook, either 'actions' or 'filters'
		 * @param hook The hook (namespace.identifier) to remove
		 * @private
		 */
		function _removeHook( type, hook, callback, context ) {
			var handlers, handler, i;
			
			if ( !STORAGE[ type ][ hook ] ) {
				return;
			}
			if ( !callback ) {
				STORAGE[ type ][ hook ] = [];
			} else {
				handlers = STORAGE[ type ][ hook ];
				if ( !context ) {
					for ( i = handlers.length; i--; ) {
						if ( handlers[i].callback === callback ) {
							handlers.splice( i, 1 );
						}
					}
				}
				else {
					for ( i = handlers.length; i--; ) {
						handler = handlers[i];
						if ( handler.callback === callback && handler.context === context) {
							handlers.splice( i, 1 );
						}
					}
				}
			}
		}

		/**
		 * Adds the hook to the appropriate storage container
		 *
		 * @param type 'actions' or 'filters'
		 * @param hook The hook (namespace.identifier) to add to our event manager
		 * @param callback The function that will be called when the hook is executed.
		 * @param priority The priority of this hook. Must be an integer.
		 * @param [context] A value to be used for this
		 * @private
		 */
		function _addHook( type, hook, callback, priority, context ) {
			var hookObject = {
				callback : callback,
				priority : priority,
				context : context
			};

			// Utilize 'prop itself' : http://jsperf.com/hasownproperty-vs-in-vs-undefined/19
			var hooks = STORAGE[ type ][ hook ];
			if( hooks ) {
				hooks.push( hookObject );
				hooks = _hookInsertSort( hooks );
			}
			else {
				hooks = [ hookObject ];
			}

			STORAGE[ type ][ hook ] = hooks;
		}

		/**
		 * Use an insert sort for keeping our hooks organized based on priority. This function is ridiculously faster
		 * than bubble sort, etc: http://jsperf.com/javascript-sort
		 *
		 * @param hooks The custom array containing all of the appropriate hooks to perform an insert sort on.
		 * @private
		 */
		function _hookInsertSort( hooks ) {
			var tmpHook, j, prevHook;
			for( var i = 1, len = hooks.length; i < len; i++ ) {
				tmpHook = hooks[ i ];
				j = i;
				while( ( prevHook = hooks[ j - 1 ] ) &&  prevHook.priority > tmpHook.priority ) {
					hooks[ j ] = hooks[ j - 1 ];
					--j;
				}
				hooks[ j ] = tmpHook;
			}

			return hooks;
		}

		/**
		 * Runs the specified hook. If it is an action, the value is not modified but if it is a filter, it is.
		 *
		 * @param type 'actions' or 'filters'
		 * @param hook The hook ( namespace.identifier ) to be ran.
		 * @param args Arguments to pass to the action/filter. If it's a filter, args is actually a single parameter.
		 * @private
		 */
		function _runHook( type, hook, args ) {
			var handlers = STORAGE[ type ][ hook ], i, len;
			
			if ( !handlers ) {
				return (type === 'filters') ? args[0] : false;
			}

			len = handlers.length;
			if ( type === 'filters' ) {
				for ( i = 0; i < len; i++ ) {
					args[ 0 ] = handlers[ i ].callback.apply( handlers[ i ].context, args );
				}
			} else {
				for ( i = 0; i < len; i++ ) {
					handlers[ i ].callback.apply( handlers[ i ].context, args );
				}
			}

			return ( type === 'filters' ) ? args[ 0 ] : true;
		}

		// return all of the publicly available methods
		return MethodsAvailable;

	};
	
	window.wp = window.wp || {};
	window.wp.hooks = new EventManager();

} )( window );

/*
 Tipr 2.0
 Copyright (c) 2015 Tipue
 Tipr is released under the MIT License
 http://www.tipue.com/tipr
 */


(function ( $ ) {

	$.fn.tipr = function ( options ) {

		var set = $.extend( {

			'speed': 200,
			'mode': 'bottom'

		}, options );

		return this.each( function () {

			var tipr_cont = '.tipr_container_' + set.mode;

			$( this ).hover(
				function () {
					var d_m = set.mode;

					if ( $( this ).attr( 'data-mode' ) ) {
						d_m = $( this ).attr( 'data-mode' )
						tipr_cont = '.tipr_container_' + d_m;
					}

					var out = '<div class="tipr_container_' + d_m + '"><div class="tipr_point_' + d_m + '"><div class="tipr_content">' + $( this ).attr( 'data-tip' ) + '</div></div></div>';

					$( this ).append( out );

					var w_t = $( tipr_cont ).outerWidth();
					var w_e = $( this ).width();
					var m_l = (w_e / 2) - (w_t / 2);

					$( tipr_cont ).css( 'margin-left', m_l + 'px' );
					$( this ).removeAttr( 'title alt' );

					if ( d_m == 'bottom' ) {
						$( tipr_cont ).css( 'margin-top', ( $( this ).outerHeight() / 2 ) + 'px' );
					}

					$( tipr_cont ).fadeIn( set.speed );
				},
				function () {
					$( tipr_cont ).remove();
				}
			);

		} );
	};

})( jQuery );
/**
 * Defines Project Huddle namespace
 * @since 1.0
 */

// strict mode
'use strict';

// global namespace
var Huddle = window.Huddle = {

	start: function ( data ) {
		this.setGlobals( data );

        // start router
        if ( !Huddle.router ) {
            Huddle.router = new Huddle.ProjectRouter();
        }

        Huddle.project = new Huddle.Project(data);
        // create project view
        Huddle.container = new Huddle.ProjectHuddleView({
            model: Huddle.project
        });
        Huddle.container.inject('.project-huddle');

		// start history
		if ( !Backbone.History.started ) {
			Backbone.history.start();
		}

		// remove top bar on chrome
        window.scrollTo(0,1);

		// broadcast init
		wp.hooks.doAction( 'Huddle.start', this );
	},

	setGlobals: function ( data ) {
        // global body and window
        Huddle.body = jQuery('body');
        Huddle.window = jQuery(window);

		// set global project id variable
		Huddle.projectID = data ? data.project_id : false;

		// set global site url variable
		Huddle.siteURL = data ? data.site_url : false;

		// store global permalink variable
		Huddle.baseURL = data ? data.permalink : false;

		// get options
		Huddle.options = data ? data.options : false;

		// get translations
		Huddle.translations = PH_Settings ? PH_Settings.translations : false;

        Huddle.editorFormats = ['bold', 'italic', 'blockquote', 'code-block', 'link', 'list', 'code', 'image'];
        Huddle.editorOptions = ['bold', 'italic', 'blockquote', 'code-block', 'link', { 'list': 'ordered'}, { 'list': 'bullet' }];

		// global state model
		Huddle.state = new Huddle.State();

		// create user model
		Huddle.user = data ? new Huddle.User( data.user ) : new Huddle.User();

		// store me
		Huddle.me  = new wp.api.models.UsersMe(data.me || {});

		// create new parent view for dialogs
		Huddle.dialog = new Huddle.DialogView();

		// create image collection model
		Huddle.images = data ? new Huddle.ImageCollection( data.images ) : new Huddle.ImageCollection();

		// set convenience permissions
		Huddle.permissions = new Huddle.Permissions();
	},

	currentImageHash: function() {
        Huddle.images.get(Huddle.state.get('image')).get('slug');
	},

    setLinkPlaceholder: function (quill) {
        var input          = quill.theme.tooltip.root.querySelector("input[data-link]");
        input.dataset.link = 'http://';
    },

    isWhitespace: function (ch) {
        var whiteSpace = false;
        if ((ch == ' ') || (ch == '\t') || (ch == '\n')) {
            whiteSpace = true;
        }
        return whiteSpace;
    },

    // Autolink URLs when typing or pasting
    autoLinkHighlight: function(quill) {
        quill.on('text-change', _.bind( function(delta, oldDelta, source) {
            var regex = /https?:\/\/[^\s]+$/;
            if(delta.ops.length === 2 && delta.ops[0].retain && this.isWhitespace(delta.ops[1].insert)) {
                var endRetain = delta.ops[0].retain;
                var text = quill.getText().substr(0, endRetain);
                var match = text.match(regex);

                if(match !== null) {
                    var url = match[0];

                    var ops = [];
                    if(endRetain > url.length) {
                        ops.push({ retain: endRetain - url.length });
                    }

                    ops = ops.concat([
                        { delete: url.length },
                        { insert: url, attributes: { link: url } }
                    ]);

                    quill.updateContents({
                        ops: ops
                    });
                }
            }
        }, this ));

        quill.clipboard.addMatcher(Node.TEXT_NODE, function(node, delta) {
            var regex = /https?:\/\/[^\s]+/g;
            if(typeof(node.data) !== 'string') return;
            var matches = node.data.match(regex);

            if(matches && matches.length > 0) {
                var ops = [];
                var str = node.data;
                matches.forEach(function(match) {
                    var split = str.split(match);
                    var beforeLink = split.shift();
                    ops.push({ insert: beforeLink });
                    ops.push({ insert: match, attributes: { link: match } });
                    str = split.join(match);
                });
                ops.push({ insert: str });
                delta.ops = ops;
            }

            return delta;
        });
	}
};
/**
 * Mixins used in the app. Used to sync admin-ajax.php with backbone
 *
 * @package     ProjectHuddle
 * @subpackage  js
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0.0
 */

/**
 * Base model for our models to extend
 */
Huddle.BaseModel = {
	/**
	 * Custom sync method for PH models
	 * Set nonce header before every Backbone sync.
	 * Check for user registration and trigger identify event
	 *
	 * @param {string} method.
	 * @param {Backbone.Model} model.
	 * @param {{beforeSend}, *} options.
	 * @returns {*}.
	 */
	sync: function (method, model, options) {
		var beforeSend;

		options = options || {};

		// short circuit if user is not logged in
		if (!Huddle.me.get('id')) {
			Huddle.Event.trigger('register', this, this.changedAttributes());
			return false;
		}

		// Remove date_gmt if null.
		if (_.isNull(model.get('date_gmt'))) {
			model.unset('date_gmt');
		}

		// Remove slug if empty.
		if (_.isEmpty(model.get('slug'))) {
			model.unset('slug');
		}

		if (!_.isUndefined(wpApiSettings.nonce) && !_.isNull(wpApiSettings.nonce)) {
			beforeSend = options.beforeSend;

			// @todo enable option for jsonp endpoints
			// options.dataType = 'jsonp';

			options.beforeSend = function (xhr) {
				xhr.setRequestHeader('X-WP-Nonce', wpApiSettings.nonce);

				if (beforeSend) {
					return beforeSend.apply(this, arguments);
				}
			};
		}

		// Add '?force=true' to use delete method when required.
		if (this.requireForceForDelete && 'delete' === method) {
			model.url = model.url() + '?force=true';
		}

		// Post data as FormData object on create to allow file upload
		if (options.formData) {
			var formData = new FormData();

			// Loop over model attributes and append to formData
			_.each(model.attributes, function (value, key) {
				formData.append(key, value);
			});

			_.defaults(options || (options = {}), {
				data       : formData,
				method     : 'POST',
				contentType: false,
				processData: false,
				xhr        : function () {
					// get the native XmlHttpRequest object
					var xhr               = jQuery.ajaxSettings.xhr();
					// set the onprogress event handler
					xhr.upload.onprogress = function (event) {
						if (event.lengthComputable) {
							// console.log('%d%', (event.loaded / event.total) * 100);
							// Trigger progress event on model for view updates
							model.trigger('progress', (event.loaded / event.total) * 100);
						}
					};
					// set the onload event handler
					xhr.upload.onload     = function () {
						// console.log('complete');
						model.trigger('progress', 100);
					};
					// return the customized object
					return xhr;
				}
			});
		}

		return Backbone.sync(method, model, options);
	},

	/**
	 * Process stored items
	 */
	stored: function () {
		var modelID    = this.get('id') || Huddle.projectID;
		var storedJSON = window.sessionStorage.getItem('phState' + modelID),
			stored     = storedJSON && JSON.parse(storedJSON);

		// remove item from storage
		sessionStorage.removeItem('phState' + modelID);

		// trigger stored event
		if (stored) {
			// new items
			if (stored.new) {
				this.trigger('stored:new', stored.new);
			} else if (stored.modified) {
				// patch in modifications
				this.save(stored.modified, {
					patch: true
				});

				// trigger complete
				this.trigger('stored:modified');
			}
		}
	},

	getImages: function (options) {
		options || (options = {});
		options = _.defaults(options, {fetch: true});
		return this.buildCollectionGetter(this, 'ImageCollection', 'images', 0, options.fetch);
	},

	getThreads: function (options) {
		options || (options = {});
		options = _.defaults(options, {fetch: true});
		return this.buildCollectionGetter(this, 'CommentCollection', 'threads', 0, options.fetch);
	},

	getComments: function (options) {
		options || (options = {});
		options = _.defaults(options, {fetch: true});
		return this.buildCollectionGetter(this, 'CommentItemCollection', 'replies', 0, options.fetch);
	},

	/**
	 * Build a helper to retrieve a collection.
	 *
	 * @param  {string} parentModel      The parent model.
	 * @param  {string} collectionName   The name to use when constructing the collection.
	 * @param  {string} embedSourcePoint Where to check the embedds object for _embed data.
	 * @param  {string} embedIndex       An addiitonal optional index for the _embed data.
	 * @param  {boolean} shouldFetch     Should we try fetching if it doesn't exist?
	 *
	 * @return {Deferred.promise}        A promise which resolves to the constructed collection.
	 */
	buildCollectionGetter: function( parentModel, collectionName, embedSourcePoint, embedIndex, shouldFetch ) {
		/**
		 * Returns a promise that resolves to the requested collection
		 *
		 * Uses the embedded data if available, otherwises fetches the
		 * data from the server.
		 *
		 * @return {Deferred.promise} promise Resolves to a wp.api.collections[ collectionName ]
		 * collection.
		 */
		var postId, embeddeds, getObjects,
			classProperties = '',
			properties      = '',
			collection 		= '',
			deferred        = jQuery.Deferred();

		postId    = parentModel.get( 'id' );
		embeddeds = parentModel.get( '_embedded' ) || {};

		// Verify that we have a valid post id.
		if ( ! _.isNumber( postId ) || 0 === postId ) {
			deferred.reject();
			return deferred;
		}

		// If we have embedded getObjects data, use that when constructing the getObjects.
		if ( ! _.isUndefined( embedSourcePoint ) && ! _.isUndefined( embeddeds[ embedSourcePoint ] ) ) {

			// Some embeds also include an index offset, check for that.
			if ( _.isUndefined( embedIndex ) ) {

				// Use the embed source point directly.
				properties = embeddeds[ embedSourcePoint ];
			} else {

				// Add the index to the embed source point.
				properties = embeddeds[ embedSourcePoint ][ embedIndex ];
			}
		} else {

			// Otherwise use the postId.
			classProperties = { parent_id : postId };
		}

		// Create the new getObjects collection.
		getObjects = new Huddle[ collectionName ]( properties, classProperties );

		// If we didn’t have embedded getObjects, fetch the getObjects data.
		if ( _.isUndefined( getObjects.models[0] ) ) {
			if( _.isUndefined( shouldFetch ) || shouldFetch === true ) {
				getObjects.fetch({
					success: (function (getObjects) {
						// Add a helper 'parent_post' attribute onto the model.
						this.setHelperParentPost(getObjects, postId);
						deferred.resolve(getObjects);
					}).bind(this),
					error  : function (getModel, response) {
						deferred.reject(response);
					}
				});
			}
		} else {

			// Add a helper 'parent_post' attribute onto the model.
			this.setHelperParentPost( getObjects, postId );
			deferred.resolve( getObjects );
		}

		// Return a promise.
		return deferred.promise();

	},

	/**
	 * Set the model post parent.
	 */
	setHelperParentPost: function( collection, postId ) {

		// Attach post_parent id to the collection.
		_.each( collection.models, function( model ) {
			model.set( 'parent_post', postId );
		} );
	}
};

Huddle.BaseCollection = {
	save: function (key, val, options) {
		// extend options
		options = _.extend({
			url: wpApiSettings.root + wpApiSettings.versionString + 'batch'
		}, options);

		// success/error
		var success = options.success;
		var error   = options.error;

		// prepare bulk request
		var request = this.prepareBulkRequest();

		// run ajax call
		return Backbone.ajax({
			url        : options.url,
			method     : 'PUT',
			contentType: 'application/json',
			data       : JSON.stringify({requests: request}),

			beforeSend: function (xhr) {
				xhr.setRequestHeader('X-WP-Nonce', wpApiSettings.nonce);
			},

			success: _.bind(function (resp, model) {
				if (success) success.call(options.context, this, resp, options);
			},this),

			error: function (xhr, textStatus, errorThrown) {
				if (xhr && xhr.responseJSON && xhr.responseJSON.message) {
					toastr.error(xhr.responseJSON.message);
				} else if (textStatus !== "parsererror") {
					toastr.error(Huddle.translations.generic_error);
				}
				console.error(arguments);

				if (error) error.call(options.context, xhr, textStatus, errorThrown);
			}
		});
	},

	prepareBulkRequest: function () {
		var requests = [];

		this.forEach(function (model) {
			requests.push({
				method: model.isNew() ? 'POST' : 'PATCH',
				route : model.url(),
				params: model.changedAttributes()
			});
		});

		return requests;
	}
};

/**
 * A view for all wp views to extend
 *
 * Extends wp.Backbone.View with .prepare() and .inject()
 *
 * @since 1.0.0
 */
Huddle.View = wp.Backbone.View.extend({
	inject: function (selector) {
		this.render();
		jQuery(selector).html(this.el);
		this.views.ready();
	},

	prepare: function () {
		if (!_.isUndefined(this.model) && _.isFunction(this.model.toJSON)) {
			this._parseTriggers();
			return this.model.toJSON();
		} else {
			return {};
		}
	},

	_parseTriggers: function () {
		if (this.triggers) {
			_.each(this.triggers || {}, function (fn, event) {

				// objects
				if (typeof fn == 'object') {
					_.each(fn, function (fn) {
						var oHandler = this[fn];
						if (_.isFunction(oHandler)) {
							this.stopListening(this.model, event, oHandler);
							this.listenTo(this.model, event, oHandler);
						}
					}, this);
					return false;
				}

				// regular
				var handler = this[fn];
				if (_.isFunction(handler)) {
					this.stopListening(this.model, event, handler);
					this.listenTo(this.model, event, handler);
				}
			}, this);
		}
	}
});

_.mixin({
	/**
	 * Convert /n newline to <br>
	 *
	 * @param str String to convert
	 * @param is_xhtml Use xhtml tag
	 * @returns {string} Output with <br> tag
	 *
	 * @since 1.0.0
	 */
	nl2br: function (str, is_xhtml) {
		var breakTag = (is_xhtml || typeof is_xhtml === 'undefined') ? '<br />' : '<br>';
		return (str + '').replace(/([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1' + breakTag + '$2');
	},

	/**
	 * Captialize
	 * @param string
	 * @returns {string}
	 */
	capitalize: function (string) {
		return string.charAt(0).toUpperCase() + string.substring(1).toLowerCase();
	},

	/**
	 * Human readable time
	 *
	 * @param time
	 * @returns {*}
	 */
	timeSince: function (time) {
		switch (typeof time) {
			case 'number':
				break;
			case 'string':
				time = +new Date(time);
				break;
			case 'object':
				if (time.constructor === Date) time = time.getTime();
				break;
			default:
				time = +new Date();
		}

		var time_formats = [
			[60, 's', 1], // 60
			[120, '1m', '1m'], // 60*2
			[3600, 'm', 60], // 60*60, 60
			[7200, '1h', '1h'], // 60*60*2
			[86400, 'h', 3600], // 60*60*24, 60*60
			[172800, '1d', '1d'], // 60*60*24*2
			[604800, 'd', 86400], // 60*60*24*7, 60*60*24
			[1209600, '1w', '1w'], // 60*60*24*7*4*2
			[2419200, 'w', 604800], // 60*60*24*7*4, 60*60*24*7
			[4838400, '1mth', '1mth'], // 60*60*24*7*4*2
			[29030400, 'mths', 2419200], // 60*60*24*7*4*12, 60*60*24*7*4
			[58060800, 'y', '1y'], // 60*60*24*7*4*12*2
			[2903040000, 'y', 29030400] // 60*60*24*7*4*12*100, 60*60*24*7*4*12
		];

		// use gmt
		var now     = new Date();
		var now_utc = new Date(now.getUTCFullYear(), now.getUTCMonth(), now.getUTCDate(), now.getUTCHours(), now.getUTCMinutes(), now.getUTCSeconds());

		var seconds     = (+now_utc.getTime() - time) / 1000,
			token       = 'ago',
			list_choice = 1;

		if (seconds == 0) {
			return 'Now'
		}
		if (seconds < 0) {
			seconds     = Math.abs(seconds);
			token       = 'from now';
			list_choice = 2;
		}
		var i = 0,
			format;
		while (format = time_formats[i++]) {
			if (seconds < format[0]) {
				if (typeof format[2] === 'string')
					return format[list_choice];
				else
					return Math.floor(seconds / format[2]) + format[1];
			}
		}
		return time;
	}
});
/**
 * Declare global events in namespace
 */
Huddle.Event = _.extend( {}, Backbone.Events );

/**
 * Model to store our individual comment item
 *
 * @since 1.0
 */
Huddle.CommentItem = wp.api.models.Comment.extend(_.defaults({
	defaults: _.defaults({}, wp.api.models.Comment.prototype.defaults, {
		'edit'    : false,
		'moderate': false,
		'attachments': []
	}),

	initialize: function (attributes, options) {
		// init parent
		wp.api.models.Comment.prototype.initialize.call(this, attributes, options);

		// set attributes
		this.set({
			'humanDate': this.get('date_gmt') ? _.timeSince(this.get('date_gmt')) : 'Now',
			'moderate' : this.get('author') === Huddle.me.get('id')
		});

		// hook into init
		wp.hooks.doAction('Huddle.CommentItem.' + arguments.callee.name, this);
	}
}, Huddle.BaseModel));
/**
 * Model to store our individual parent comments with location
 *
 * @extends BaseModel Sync, save, fetch, update functions with app-ajax
 *
 * @since 1.0
 */
Huddle.Comment = wp.api.models.MockupThread.extend(_.defaults({
	defaults: _.extend({}, wp.api.models.MockupThread.prototype.defaults, {
			comment_content: '',
			comments       : [],
			order          : 0,
			show           : false,
			scroll         : false,
			hover          : false,
			focus          : false,
			controls       : false,
			assigned       : 0,
			assigned_model : {
				avatar_urls: {
					96: ''
				},
				name       : ''
			},
			humanDate      : ''
		}
	),

	initialize: function (attributes, options) {
		// init parent
		wp.api.models.MockupThread.prototype.initialize.call(this, attributes, options);

		this.set('comments', new Huddle.CommentItemCollection(this.get('comments') || []));

		// listen to submit
		this.listenTo(this, 'submit', this.saveThread);
		this.listenTo(this, 'submit', this.createComment);
		this.listenTo(this, 'change:show', this.maybeDestroy);
		this.listenTo(this, 'change:show', this.onlyOneShow);
		this.listenTo(this, 'change:controls', this.maybeClear);

		// broadcast init
		wp.hooks.doAction('Huddle.Comment.initialize', this);
	},

	// update comments subcollection on parse
	parse: function (response, options) {
		// rule out patch requests that don't contain comments
		if (options.patch === true) {
			if (typeof options.attrs.comments === 'undefined') {
				response.comments = this.get('comments');
				return response;
			}
		}

		// handle comments sync
		if (response.comments && this.get('comments')) {
			// set models comments to response
			this.get('comments').set(response.comments);
			response.comments = this.get('comments');
		}
		return response;
	},

	// save thread and comment
	saveThread: function () {
		if (!this.isNew()) {
			return;
		}

		// add comment to response
		this.get('comments').add(wp.hooks.applyFilters('ph_new_comment_data', {
			'author_name'       : Huddle.me.get('name'),
			'content'           : this.get('comment_content'),
			'post'              : this.get('id'),
			'author'            : Huddle.me.get('id'),
			'author_avatar_urls': Huddle.me.get('avatar_urls')
		}, this));

		// save thread with comment
		this.save(wp.hooks.applyFilters('ph_new_thread_data', {
			content  : this.get('comment_content'),
			parent_id: Huddle.state.get('image'),
			mockup_id: Huddle.projectID,
			slug     : _.uniqueId(),
			author   : Huddle.me ? Huddle.me.get('id') : 0
		}, this), {
			success: function (model) {
				PH_Settings.debug && console.log('New Thread:', model); // debug
			},
			// remove on error
			error  : (function (model, response, xhr) {
				this.get('comments').remove(model);
				Huddle.Event.trigger('error', model, response, xhr);
			}).bind(this)
		});

		// clear comment content
		this.set('comment_content', '');

		PH_Settings.options.global.auto_close && this.autoHide();
	},

	// Create/Add Comment
	createComment: function () {
		if (this.isNew()) {
			return;
		}

		// create comment
		this.get('comments').create(wp.hooks.applyFilters('ph_new_comment_data', {
			'author_name'       : Huddle.me.get('name'),
			'content'           : this.get('comment_content'),
			'post'              : this.get('id'),
			'author'            : Huddle.me.get('id'),
			'author_avatar_urls': Huddle.me.get('avatar_urls')
		}, this), {
			success: function (model) {
				PH_Settings.debug && console.log('New Comment:', model); // debug
			},
			error  : (function (model, response, xhr) {
				this.get('comments').remove(model);
				Huddle.Event.trigger('error', model, response, xhr);
			}).bind(this)
		});

		// reset content in form
		this.set('comment_content', '');
	},

	// Auto hide comment after 1.5 seconds
	autoHide: function () {
		this.hiding = _.delay(_.bind(function () {
			this.set({'show': false});
		}, this), 1500); // wait a second and a half
	},

	// Kill autohide timer
	cancelAutoHide: function () {
		clearTimeout(this.hiding); //Kill the timer
	},

	maybeClear: function () {
		if (this.get('controls'))
			return; // only if we're hiding

		if (this.get('comment_content') && this.get('comment_content') !== '<p><br></p>') {
			vex.dialog.confirm({
				message : Huddle.translations.discard,
				callback: (function (value) {
					if (value) {
						if (this.isNew()) {
							this.destroyThread();
						} else {
							this.set({
								'comment_content': '',
								'controls'       : false,
							}).trigger('resetTextArea');
						}
					}
				}).bind(this)
			});
		}
	},

	// maybe destroy thread
	maybeDestroy: function () {
		if (this.get('show'))
			return; // only if we're hiding

		if (this.get('comment_content') && this.get('comment_content') !== '<p><br></p>') {
			this.confirmDelete(); // confirm delete if form content
		} else if (!this.get('comments').length) {
			this.destroyThread(); // else if there are no comments, destroy automatically
		}
	},

	confirmDelete: function () {
		vex.dialog.confirm({
			message : Huddle.translations.discard,
			callback: (function (value) {
				if (value) {
					if (this.isNew()) {
						this.destroyThread();
					} else {
						this.set({
							'comment_content': '',
							'controls'       : false,
							'show'           : false
						}).trigger('resetTextArea');
					}
				}
			}).bind(this)
		});
	},

	// destroy thread model
	destroyThread: function () {
		if (wp.hooks.applyFilters('ph_destroy_thread', true, this)) {
			this.destroy();
		}
	},

	// make sure only one in a collection can show at once
	onlyOneShow: function (model) {
		if (model.get('show')) {
			this.collection.forEach(function (model) {
				if (model.id !== this.id) {
					model.set('show', false);
				}
			}, this);
		}
	}
}, Huddle.BaseModel));
/**
 * Model to store our individual images
 *
 * Handles and orchestrates all listeners for threads.
 *
 * @extends BaseModel Sync, save, fetch, update functions with admin-ajax
 *
 * @since 1.0
 */

Huddle.Image = wp.api.models.MockupImage.extend(_.defaults({
	defaults: _.defaults({}, wp.api.models.MockupImage.prototype.defaults, {
        comment_count: 0,
        thread_count: 0,
        showComments: false,
        date: "Now",
        imageID: false,
        success: false,
        thumbnail: false,
        title: 'Image',
        humanDate: 'Now',
        url: false,
        zoom: '',
        magnification: 1,
        zoomAmount: 1.25,
        retina: false,
        hideComments: false,
        options: {
            alignment: 'center', // left or right
            size: 'normal', // normal or scale
            background_color: '#000', // hex value
            background_image: false, // background-image
            background_image_position: 'repeat' // center, repeat, repeat-x, cover
        }
    }),

    /**
     * When an image model is initialized, store the comment collection
     */
    initialize: function (attributes, options) {
		// init parent
		wp.api.models.MockupImage.prototype.initialize.call(this, attributes, options);

        // set featured image in model
		this.set('image', new wp.api.models.Media(this.get('image') || {}));

		// set threads collection in model
		this.set('threads', new Huddle.CommentCollection(this.get('threads') || []));

		// set order
		this.setOrder();

		// set order
		this.listenTo(this.get('threads'), 'add remove reset', this.setOrder);

        // set human readable date
        this.set('humanDate', _.timeSince(this.get('date')));

        // set retina on/off
        if (Huddle.options && Huddle.options.project && Huddle.options.project.retina_images) {
            this.set('retina', Huddle.options.project.retina_images);
        }

        this.listenTo(this, 'change:zoom', this.magnify);
        this.listenTo(this, 'change:zoom', _.bind(function(){
        	Huddle.Event.trigger('change:zoom', this);
		},this)); // bubble down

        // fetch image when image tray is triggered
		this.listenTo(Huddle.state, 'change:tray', this.fetchImage);

        // broadcast init
        wp.hooks.doAction('Huddle.Image.initialize', this);
    },

	// update comments subcollection on parse
	parse: function (response, options) {
		// rule out patch requests that don't contain comments
		if (options.patch === true) {
			if (typeof options.attrs.threads === 'undefined') {
				response.threads = this.get('threads');
				return response;
			}
		}

		// handle threads sync
		if (response.threads) {
			// set models threads to response
			this.get('threads').set(response.threads);
			response.threads = this.get('threads');
		}
		return response;
	},

	// fetch image
	fetchImage: function () {
		this.getFeaturedMedia().done(_.bind(function (media) {
			this.set('image', media);
		}, this));
	},

    // set magnification when zoom occurs
    magnify: function () {
        if (this.get('zoom') === 'in') {
            this.set('magnification', this.get('magnification') * this.get('zoomAmount'));
        } else {
            this.set('magnification', this.get('magnification') / this.get('zoomAmount'));
        }
    },

    /**
     * Set the order attribute in the thread collection
     * @param thread {object} Comment thread object
     */
	setOrder: function () {
		// set order
		this.get('threads').forEach(function(thread){
			thread.set({
				order: thread.collection.indexOf(thread)
			});
		});
	}
}, Huddle.BaseModel));
/**
 * Model to store our front end permissions
 *
 * This is only for convenience. Actual permissions are validated on the server.
 *
 * @extends BaseModel Sync, save, fetch, update functions with app-ajax
 *
 * @since 1.0
 */
Huddle.Permissions = Backbone.Model.extend(_.defaults({
    defaults: {
        moderate: false,
        allowComments: false,
        loggedIn: false
    },

    initialize: function () {
        // set on init
        this.setPermissions();

        // set after identify success
        this.listenTo(Huddle.Event, 'identifySuccess', this.setPermissions);

        // broadcast init
        wp.hooks.doAction('Huddle.Permissions.initialize', this);
    },

    /**
     * Set permissions model values
     */
    setPermissions: function () {
        this.loggedIn();
        this.moderateComments();
        this.allowComments();
    },

    /**
     * If user is logged in
     */
    loggedIn: function () {
        this.set('loggedIn', Huddle.user.get('logged_in'));
    },

    /**
     * User can moderate comments
     */
    moderateComments: function () {
        // var caps = Huddle.user.get('capabilities');
        // if ( caps['moderate_ph-project_comments'] !== undefined ) {
        //     this.set('moderate', caps['moderate_ph-project_comments']);
        // } else {
        //     this.set('moderate', false);
        // }
    },

    /**
     * If comments are allowed
     */
    allowComments: function () {
        // if (Huddle.options.project.allow_anon_comments == 'on' || Huddle.user.get('logged_in')) {
            this.set({
                'allowComments': true
            });
        // }
    }
}, Huddle.BaseModel));
/**
 * Model to store our Project
 *
 * Handles and orchestrates all listeners for comments.
 *
 * @extends BaseModel Sync, save, fetch, update functions with admin-ajax
 *
 * @since 1.0
 */
Huddle.Project = wp.api.models.Mockup.extend(_.defaults({
	defaults: _.defaults({}, wp.api.models.Mockup.prototype.defaults, {
		id          : null,
		approved    : false,
		name        : 'the entire project',
		options     : {},
		permalink   : '',
		filter      : 'all',
		mobileMenu  : false,
		project_id  : 0,
		showPanel   : false,
		site_url    : false,
		translations: {},
		user        : {},
		imageCount  : 0
	}),

	/**
	 * When an image model is initialized, store the comment collection
	 */
	initialize: function () {
		this.set('images', new Huddle.ImageCollection(this.get('images') || []));
		this.countImages();
		this.listenTo(this.get('images'), 'change', this.countImages);

		this.listenTo(Huddle.Event, 'error', this.handleError);
	},

	countImages: function () {
		this.set('imageCount', this.get('images').length);
	},

	handleError: function (model, response) {
		console.error(arguments);
		if (! response || typeof response.responseJSON === 'undefined') {
			toastr.error(PH_Settings.translations.unknown_error);
		}
		// expired nonce
		if (response.responseJSON.code === 'rest_cookie_invalid_nonce') {
			toastr.error(PH_Settings.translations.session_expired);
			return;
		}
		response.responseJSON.message && toastr.error(response.responseJSON.message);
	}
}, Huddle.BaseModel));
/**
 * Model to store current author info
 *
 * @extends BaseModel Sync, save, fetch, update functions with app-ajax
 *
 * @since 1.0
 */

Huddle.State = Backbone.Model.extend(_.defaults({
    defaults: {
        'comment': null,
        'image': false,
        'tray': false,
        'commentText': false,
        'x': false,
        'y': false,
        'panel': false
    },

    /**
     * When image state is changed, silently clear other attributes
     */
    initialize: function () {
        // broadcast init
        wp.hooks.doAction('Huddle.State.initialize', this);
    }
}, Huddle.BaseModel));

/**
 * Model to store current author info
 *
 * @since 1.0
 */
Huddle.User = wp.api.models.User.extend(_.defaults({
	defaults: _.defaults({}, wp.api.models.User.prototype.defaults, {
        id           : null,
        user_email   : '',
        display_name : 'Guest',
        user_nicename: 'Guest',
        username     : '',
        password     : '',
        ID           : 0,
        avatar       : ''
    }),

    initialize: function (attributes, options) {
	    // init parent
		wp.api.models.User.prototype.initialize.call(this, attributes, options);

		// set user
        this.setUser();

        // broadcast init
        wp.hooks.doAction('Huddle.User.initialize', this);
    },

    // set user from cookies if not logged in
    setUser: function() {
        if (!this.get('ID') && Cookies.get('Huddle.user')) {
            this.set(Cookies.getJSON('Huddle.user'));
        }
    },

    forget: function() {
        this.clear().set(this.defaults);
        Cookies.remove('Huddle.user');
    }
}, Huddle.BaseModel));
/**
 * Collection to store all comments for an image
 *
 * @extends BaseCollection Sync, save, fetch, update functions with app-ajax
 *
 * @since 1.0
 */
Huddle.CommentCollection = wp.api.collections.MockupThread.extend({
	// Use comment item for model in the collection
	model: Huddle.Comment,

	initialize: function (attributes, options) {
		// init parent
		wp.api.collections.MockupThread.prototype.initialize.call(this, attributes, options);

		// when added to the collection, save it automatically
		this.listenTo( this, 'newCommentLocation', this.saveLocation );

		// when comment is removed, move it to the trash
		this.listenTo( this, 'trashLocation', this.removeLocation );

		// when event is triggered, updateComment
		this.listenTo( this, "locationChanged", this.updateLocationMeta );

		// when comment is shared, email
		this.listenTo( this, 'shareComment', this.shareComment );

		// when the order is changed in a comment, save it
		this.listenTo( this, 'change:order', this.updateOrder );

		// when the location is removed, remove the model from the collection
		this.listenTo( this, 'locationRemoved', this.removeComment );

		// broadcast init
		wp.hooks.doAction( 'Huddle.CommentCollection.initialize', this );
	}
} );
/**
 * Collection to store all comments for an image
 *
 * @extends BaseCollection Sync, save, fetch, update functions with app-ajax
 *
 * @since 1.0
 */
 Huddle.CommentItemCollection =  wp.api.collections.Comments.extend({
    model: Huddle.CommentItem,

    initialize: function (attributes, options) {
		// init parent
		wp.api.collections.Comments.prototype.initialize.call(this, attributes, options);

        // broadcast init
        wp.hooks.doAction('Huddle.CommentItemCollection.initialize', this);
    }
});
/**
 * Collection to store all the images for this post
 *
 * @since 1.0
 */
Huddle.ImageCollection = wp.api.collections.MockupImage.extend(_.defaults({
	// Use image model for this collection
	model: Huddle.Image,

	initialize: function (attributes, options) {
		// init parent
		wp.api.collections.MockupImage.prototype.initialize.call(this, attributes, options);

		// image request to be shared, share image
		this.listenTo(this, 'shareImage', this.shareImage);

		// broadcast init
		wp.hooks.doAction('Huddle.ImageCollection.initialize', this);
	},

	/**
	 * Shares an image via email
	 *
	 * @param image model to share
	 */
	shareImage: function (image) {
		console.log('share' + image);
		// this.doAction( image, 'share', 'emailSuccess' );
	}
}, Huddle.BaseCollection));
/**
 * Approve Button View
 *
 * @since 1.0.0
 */
Huddle.ApproveButtonView = Huddle.View.extend({
	template: wp.template('approve-button'),
	unwrap  : true,

    events: {
        'click': 'approve'
    },

    initialize: function () {
        this.listenTo(this.model, 'change:approval', this.render);

        // broadcast init
        wp.hooks.doAction('Huddle.ApproveButtonView.initialize', this);
    },


    /**
     * Change approval in model
     */
    approve: function () {
        // if (!Huddle.permissions.get('allowComments')) {
        //     toastr.info(this.model.get('approval') ? Huddle.translations.cant_approve : Huddle.translations.cant_approve);
        //     return false;
        // }
		//
        // // if it's approved and unapprovals aren't allowed, do nothing
        // if (this.model.get('approval') && !Huddle.permissions.get('allowUnApprovals')) {
        //     toastr.info(Huddle.translations.cant_unapprove);
        //     return false;
        // }
		//
        // // if it's approved and unapprovals aren't allowed, do nothing
        // if (!this.model.get('approval') && !Huddle.permissions.get('allowApprovals')) {
        //     toastr.info(Huddle.translations.cant_approve);
        //     return false;
        // }
		//
        // // validate user data
        // if (!Huddle.user.attributes.user_email) {
        //     this.identityChecking = true;
        //     Huddle.Event.trigger('requireIdentity', this.model);
        //     return false;
        // }

        // confirm approval
        this.confirmApproval(false, _.bind(this.saveApproval, this));
    },

    saveApproval: function (options, value) {
        var approval = !this.model.get('approval');
        if (value.approve_project) {
            // change all images in collection
            this.model.collection.forEach(_.bind(function (model, index) {
                model.set('approval', approval);
            }, this));

            this.model.collection.save({}, {
                success: function() {
					toastr[approval ? 'success' : 'info'](approval ? Huddle.translations.approved : Huddle.translations.unapproved);
                }
            });
        } else {
			this.model.save({
				'approval': approval
			}, {patch: true});

			toastr[approval ? 'success' : 'info'](approval ? Huddle.translations.approved : Huddle.translations.unapproved);
        }
    },

    /**
     * Confirm approval dialog
     *
     * @param options Callback options
     * @param callback Callback function
     */
    confirmApproval: function (options, callback) {
        var t             = Huddle.translations,
            approveText   = this.model.get('approval') ? t.unapprove : t.approve,
            approveString = this.model.get('approval') && t ? t.confirmUnApprove : t.confirmApprove;


        // add image name
        var tags = {
            approval_status: approveText.toLowerCase(),
            image_number: this.model.collection.length - 1,
            image_name: this.model.get('title').rendered,
            project_name: Huddle.container.model.get('name'),
            terms: '<u class="toggle-terms">' + t.approveCheckboxLink + '</u>',
            user_name: '<strong>' + Huddle.user.get('display_name') + '</strong>'
        };

        // replace any tags with variables
        var approveReplaced = approveString.replace(/\{\{(.*?)\}\}/g, function (match, token) {
            return tags[token];
        });

        // replace any tags with variables
        var termsReplaced = t.approveCheckbox.replace(/\{\{(.*?)\}\}/g, function (match, token) {
            return tags[token];
        });

        // replace any tags with variables
        var projectReplaced = t.approveProject.replace(/\{\{(.*?)\}\}/g, function (match, token) {
            return tags[token];
        });

        var vexOptions = {
            className: 'vex-theme-dialog vex-left-buttons',
            showCloseButton: true,
            message: approveReplaced,
            afterOpen: function ($vexContent) {
                $vexContent.find('.toggle-terms').click(function () {
                    jQuery('.ph-terms').slideToggle('fast');
                });
                $vexContent.find('.approve-option').appendTo('.vex-dialog-buttons');
            },
            callback: function (value) {
                if (!value) return false;
                callback && callback(options, value);
            }
        };

        // options
        var checked = ''; //Huddle.options.global.approval_type === 'project' ? 'checked' : '';
        var hidden  = ''; //Huddle.options.global.approval_type === 'project' ? 'ph-hidden' : '';

        vexOptions.input = '';
        if ( this.model.collection.length > 1 ) {
            vexOptions.input += "<div class='approve-option " + hidden +"'><input type='checkbox' name='approve_project' " + checked + "/><label>" + projectReplaced + "</label></div>";
        }
        // if (parseInt(Huddle.options.global.require_terms)) {
            vexOptions.input += "<div class='terms'><input type='checkbox' required name='terms' /><label>" + termsReplaced + "</label></div>";
            vexOptions.input += "<div class='ph-terms'>" + t.approveTerms + "</div>";
        // }

        // confirm approval
        if ( this.model.collection.length > 1 ) { //&& Huddle.options.global.approval_type !== 'project' ) {
            vex.dialog.alert(vexOptions);
        } else {
            vex.dialog.open(vexOptions);
        }
    }
});
/**
 * Holds the Approve Button
 *
 * @since 1.0.0
 */
Huddle.ApproveContainerView = Huddle.View.extend({
    className: 'ph-approval-wrap',
    tagName: 'span',

    initialize: function () {
        // change button when image state changes
        this.listenTo(Huddle.state, 'change:image', this.setView);
    },

    buttonDisabled: function() {
        // var options = Huddle.options.project;
        // return options.allow_approve === 'off' && options.allow_unapprove === 'off';
    },

    /**
     * Adds the approval button with the right image state
     *
     * @param state State model
     */
    setView: function (state) {
        // don't show if completely disabled
        if ( this.buttonDisabled() ) {
            return;
        }
        this.views.set(new Huddle.ApproveButtonView({
            model: this.model.get('images').get(state.get('image'))
        }));
    }
});
Huddle.AvatarView = Huddle.View.extend({
	className: 'gravatar avatar',
	template : wp.template('avatar'),
	unwrap   : true
});
Huddle.CommentBubbleView = Huddle.View.extend({
	template : wp.template('ph-comment-bubble'),
	className: 'ph-comment-wrapper project-huddle-comment-bubble',

	events: {
		'keydown .ql-editor'       : 'cancelAutoHide',
		'click .ph-dropdown'       : 'cancelAutoHide',
		'hover .ph-item-controls i': 'cancelAutoHide'
	},

	triggers: {
		'change:hover change:show dropped change:x change:y': 'overflowEvents'
	},

	initialize: function () {
		// comment header
		this.views.set('.ph-comment-header', new Huddle.CommentHeaderView({
			model: this.model
		}));

		// comment form view
		this.views.add('.ph-comment-form', new Huddle.CommentFormView({
			model: this.model
		}));

		// form controls view
		this.views.add('.ph-comment-form', new Huddle.CommentFormControlsView({
			model : this.model
		}));

		// submit/cancel button view
		this.views.set('.ph-comment-submit', new Huddle.CommentSubmitControlsView({
			model: this.model
		}));

		// comment items
		this.setComments();

		// comments added
		this.listenTo(this.model.get('comments'), 'update reset', this.scrollBottom);
		this.listenTo(this.model.get('comments'), 'update reset', this.setComments);

		_.bindAll(this, 'fixOverflow');

		// overflow events on window resize
		jQuery('window').on('resize', _.bind(this.overflowEvents, this));
	},

	// set comment subviews
	setComments: function () {
		var views = [];
		this.model.get('comments').forEach(function (item) {
			views.push(new Huddle.CommentItemView({
				model: item
			}));
		}, this);
		this.views.set('.ph-comment-text', views);
	},

	// cache subview regions
	regions: function () {
		this.commentsList = this.$('.ph-comment-text');
	},

	// dom is ready
	ready: function () {
		// cache subview regions
		this.regions();

		// scrolls to bottom of comments
		this.scrollBottom();

		// fix overflow on scroll
		this.$el.closest('.ph-project-image-outer').on('scroll', _.bind(this.fixOverflow, this));
	},

	// scroll to bottom of list
	scrollBottom: function () {
		typeof this.commentsList !== 'undefined' && this.commentsList.scrollTop(this.commentsList[0].scrollHeight);
	},

	cancelAutoHide: function () {
		this.model.cancelAutoHide();
	},

	overflowEvents: function () {
		_.defer(this.fixOverflow);
	},

	fixOverflow: function () {
		// get rect
		var rect       = this.el.getBoundingClientRect(),
			width      = rect.width,
			height     = rect.height,
			$container = this.$el.closest('.ph-project-image-outer'),
			container  = this.$el.closest('.ph-comment-thread');

		var windowOffsetY = (this.model.get('y') - $container.scrollTop() - 48);
		var windowOffsetX = (this.model.get('x') - $container.scrollLeft() + 38);
		var diffX         = Math.max(0, parseInt(windowOffsetX) + width - $container.outerWidth());
		var diffY         = Math.max(0, height + parseInt(windowOffsetY) - $container.outerHeight());

		// stop when at top
		if (diffY > height - 48) {
			diffY = height - 48;
		}

		if ( diffX > width + 38 ) {
			diffX = width + 38;
		}

		if ( diffX ) {
			container.toggleClass('ph-left-overflow', width > this.model.get('x') || $container.outerWidth() < width + 200 );
		} else {
			container.removeClass('ph-left-overflow');
		}

		var ypos = -diffY;
		var xpos = 0;

		if (container.hasClass('ph-left-overflow') && container.hasClass('ph-right-overflow')) {
			xpos = diffX < 56 ? -diffX : -(diffX - 56);
			ypos = 0;
		}

		this.$el.css({
			'transform': 'translate(' + xpos + 'px, ' + ypos + 'px )'
		});

		// toggle right overflow class
		container.toggleClass('ph-right-overflow', diffX !== 0);
	}
});
/**
 * View to show our comment button
 *
 * @since 1.0
 */
Huddle.CommentCancelButtonView = Huddle.View.extend({
    template: wp.template('ph-comment-cancel-button'),
    className: 'ph-cancel',
    tagName: 'span',

    events: {
        'click': 'cancel'
    },

    cancel: function () {
		_.defer(_.bind(function () {
			this.model.set({
				controls: false
			});
		}, this));
    }
});
/**
 * View to show our comment button
 *
 * @since 1.0
 */
Huddle.CommentCloseView = Huddle.View.extend({
	template: wp.template('ph-close-comment'),
	className: 'ph-header-controls',
	tagName: 'span',

	events: {
		'click': 'hide'
	},

	hide: function () {
		_.defer(_.bind(function () {
			this.model.set('show', false);
		}, this));
	}
});
/**
 * Comments Button Views
 */
Huddle.CommentDetailsView = Huddle.View.extend({
	template : wp.template('ph-comment-tech-details'),
	className: 'ph-tech-details',

	events: {
		'click .ph-click-open': 'toggleClass'
	},

	initialize: function () {
		// show linkview only if we have the link
		if (this.model.isNew()) {
			this.listenToOnce(this.model, 'sync', this.linkView);
		} else {
			this.views.add('.ph-dropdown-inner', new Huddle.CommentDetailLinkView({
				model: this.model
			}));
			this.views.add('.ph-dropdown-inner', new Huddle.CommentShareLinkView({
				model: this.model
			}));
		}

		// must be logged in to show
		if (!Huddle.me.isNew() && Huddle.me.can('delete_ph_comment_locations')) {
			this.views.add('.ph-dropdown-inner', new Huddle.CommentDetailDeleteView({
				model: this.model
			}));
		}
	},

	toggleClass: function (e) {
		var item = jQuery(e.currentTarget);
		jQuery('.ph-open').not(item).removeClass('ph-open');
		item.toggleClass('ph-open');
		e.stopPropagation();
	}
});

Huddle.CommentDetailLinkView = Huddle.View.extend({
	template : wp.template('ph-detail-link'),
	className: 'ph-tech-detail ph-link-tech-detail',

	events: {
		'click': 'copy'
	},

	copy: function (e) {
		new Huddle.CopyDialogView( {
			model: this.model
		} ).render();

		e.preventDefault();
		return false;
	}
});

Huddle.CommentShareLinkView = Huddle.View.extend({
	template : wp.template('ph-thread-share'),
	className: 'ph-tech-detail ph-link-tech-detail',

	events: {
		'click': 'share'
	},

	share: function () {
		// create and render view
		new Huddle.ShareDialogView({
			model: this.model
		}).render();
	}
});

Huddle.CommentDetailDeleteView = Huddle.View.extend({
	template : wp.template('ph-detail-delete'),
	className: 'ph-tech-detail ph-delete-tech-detail',

	events: {
		'click': 'trash'
	},

	trash: function () {
		vex.dialog.confirm({
			message : Huddle.translations.confirm_trash_thread,
			callback: (function (value) {
				if (value) {
					this.model.destroy({
						wait: true
					});
				}
			}).bind(this)
		});
	}
});
Huddle.CommentDotView = Huddle.View.extend({
	template : wp.template('ph-website-comment-dot'),
	className: 'ph-annotation-dot',

	triggers: {
		'change:resolved': 'resolvedClass',
		'change:order'   : 'render'
	},

	initialize: function () {
		this.resolvedClass();
	},

	resolvedClass: function () {
		this.$el.toggleClass('ph-approved', !!+this.model.get('resolved'));
	}
});
/**
 * View to show our individual comment item edit box
 *
 * @since 1.0
 */
Huddle.CommentEditFormView = Huddle.View.extend({
	template : wp.template('edit-comment-form'),
	className: 'ph-edit-form',

	events: {
		'click .ph-edit-cancel'      : 'cancelEdit',
		'click .ph-edit-save:enabled': 'updateComment'
	},

	initialize: function () {
		this.listenTo(this.model, 'change:edit', this.toggleEdit);
		this.listenTo(this.model, 'change:edit', this.setQuill);
	},

	ready: function () {
		this.toggleEdit();
	},

	setQuill: function () {
		if (!this.quill) {
			this.quill = new Quill(this.$('.ph-edit-content').get(0), {
				modules: {toolbar: Huddle.editorOptions},
				formats: Huddle.editorFormats,
				theme  : 'bubble',
				bounds : this.el
			});
			Huddle.autoLinkHighlight(this.quill);
			Huddle.setLinkPlaceholder(this.quill);
		}
	},

	toggleEdit: function () {
		this.$el.toggle(this.model.get('edit'));
	},

	cancelEdit: function () {
		this.model.set('edit', false);
	},

	updateComment: function () {
		this.model.save({
			'content': this.$('.ql-editor').html(),
			'edit'   : false // done editing
		}, {patch: true});
		return false;
	}
});
/**
 * View to show our comment form
 *
 * @since 1.0
 */
Huddle.CommentFormView = Huddle.View.extend({
    className: 'comment-textarea',
    tagName: 'div',

    events: {
        "keydown .ql-editor": "keyDownHandler",
        "focus .ql-editor": "textAreaFocus",
        "mouseover .ql-editor": 'cancelAutoHide'
    },

    /**
     * Model trigger handlers
     */
    triggers: {
        'disableTextArea': 'disableTextArea',
        'resetTextArea': 'resetTextArea',
        'focusTextArea': [
            'enableTextArea',
            'resetTextArea',
            'focusTextArea'
        ],
        'enableTextArea': 'enableTextArea',
        'change:controls': 'focusClass',
        'change:focus': 'focusHandler'
    },

    initialize: function() {
        // reset textarea when comment is added
        this.listenTo(this.model.get('comments'), 'add', this.resetTextArea);
    },

	ready: function() {
        this.setQuill();
        this.focusHandler();
	},

    focusHandler: function() {
        this.model.get('focus') && this.focusTextArea();
    },

	setQuill: function() {
        this.quill = new Quill(this.$el.html('<div class="comment-container-inner"></div>').get(0), {
            modules: { toolbar: Huddle.editorOptions },
            formats: Huddle.editorFormats,
            bounds: this.el,
            placeholder: Huddle.translations && Huddle.translations.comment_placeholder
                ? Huddle.translations.comment_placeholder
                : 'Leave a comment',
            theme: 'bubble'
        });

        Huddle.autoLinkHighlight(this.quill);
        Huddle.setLinkPlaceholder(this.quill);

        // on text-change
        this.quill.on('text-change', _.bind(this.contentChangedHandler, this));
	},

    textAreaFocus: function() {
        this.cancelAutoHide();
        this.model.set('controls', true);
    },

    focusClass: function() {
        this.$el.toggleClass('focus', this.model.get('controls'));
    },

    disableTextArea: function () {
        this.quill.disable();
    },

    enableTextArea: function () {
        this.quill.enable();
    },

    focusTextArea: function () {
        _.delay(_.bind(function() { this.quill.focus(); }, this), 100);
    },

    resetTextArea: function() {
        this.quill.setContents([{insert: '\n'}]);
        this.$('.ql-tooltip').addClass('.ql-hidden');
    },

    contentChangedHandler: function (delta, oldDelta, source) {
        this.model.set('comment_content', this.$('.ql-editor').html());
    },

    /**
     * Detects control + enter to submit comment
     * @param e Event
     */
    keyDownHandler: function (e) {
		this.cancelAutoHide();
        if (!(e.keyCode == 13 && e.metaKey)) return;
        e.preventDefault();
        this.model.trigger('submitComment');
    },

    destroy: function() {
        this.quill.off('text-change');
	},

    cancelAutoHide: function() {
		this.model.cancelAutoHide();
    }
});

/**
 * View to show our comment form
 *
 * @since 1.0
 */
Huddle.CommentHeaderView = Huddle.View.extend({

    template: wp.template('project-comment-header'),
    className: 'ph-header-inner',

    events: {
        'click .ph-share-comment': 'triggerCommentShare',
        'click .ph-copy-link': 'triggerCopyLink',
        'click .ph-delete-comment-location': 'deleteLocation'
    },

    // broadcast init
    initialize: function () {
        wp.hooks.doAction('Huddle.CommentHeaderView.initialize', this);
    },

    /**
     * Checks if it's a new comment
     * @returns {boolean} True if it's a new comment
     */
    newComment: function () {
        if (this.model.isNew()) {
            toastr.error(Huddle.translations.save_comment_first);
            return true;
        }
        return false;
    },

    /**
     * Trigger copy comment link
     * @param e Event
     */
    triggerCopyLink: function (e) {
        e.preventDefault();

        // bail if comment hasn't been saved yet
        if (this.newComment()) {
            return false;
        }

        // trigger event
        Huddle.Event.trigger('copyCommentLink', this.model);
    },

    /**
     * Trigger share comment
     * @param e Event
     */
    triggerCommentShare: function (e) {
        e.preventDefault();

        // bail if comment hasn't been saved yet
        if (this.model.isNew()) {
            return false;
        }

        // trigger event
        Huddle.Event.trigger('shareComment', this.model);
    },

    /**
     * Trigger delete comment location
     * @param e Event
     */
    deleteLocation: function (e) {
        vex.dialog.confirm({
            message: jQuery(e.currentTarget).data('confirm'),
            callback: _.bind(function (value) {
                if (value == false) return false;
                this.model.destroy();
            }, this)
        });

        return false;
    }

});

/**
 * View to show our comment header
 *
 * @since 1.0
 */
Huddle.CommentHeaderView = Huddle.View.extend({
	className: 'ph-header-inner',
	template : wp.template('project-comment-header'),

	events: {
		'click .ph-share-comment'          : 'triggerCommentShare',
		'click .ph-copy-link'              : 'triggerCopyLink',
		'click .ph-delete-comment-location': 'deleteLocation',
	},

	initialize: function () {
		this.views.add('.ph-comment-header-left', new Huddle.CommentDetailsView({
			model: this.model
		}));

		// resolved
		// this.views.add('.ph-comment-header-left', new Huddle.CommentResolvedView({
		// 	model: this.model
		// }));
		// region = '.ph-comment-header-right';

		// status
		// this.views.add(new Huddle.PanelStatusView({
		//     model: this.model
		// }));

		// // assigned
		// this.views.add(region, new Huddle.views.Assign({
		// 	model: this.model
		// })) ;
		//
		// close
		this.views.add('.ph-comment-header-right', new Huddle.CommentCloseView({
			model: this.model
		}));

		this.listenTo(Huddle.me, 'change:id', this.render);
	},

	/**
	 * Trigger copy comment link
	 * @param e Event
	 */
	triggerCopyLink: function (e) {
		e.preventDefault();
		Huddle.Event.trigger('copyCommentLink', this.model);
	},

	/**
	 * Trigger share comment
	 * @param e Event
	 */
	triggerCommentShare: function (e) {
		e.preventDefault();
		Huddle.Event.trigger('shareComment', this.model);
	},

	/**
	 * Trigger delete comment location
	 * @param e Event
	 */
	deleteLocation: function (e) {
		e.preventDefault();
		this.model.trigger('trashLocation', this.model);
	}
});
/**
 * View to show our comment form
 *
 * @since 1.0
 */
Huddle.CommentInfoView = Huddle.View.extend( {

	className: 'ph-comment-info-inner',

	triggers: {
		'hideMessage': 'hideMessage'
	},

	initialize: function() {
		this.listenTo( this.model.items, 'reRender', this.showChangedMessage );

		// broadcast init
		wp.hooks.doAction( 'Huddle.CommentInfoView.initialize', this );
	},

	/**
	 * Trigger message if comments changed
	 */
	showChangedMessage: function () {
		this.showMessage( Huddle.translations.comments_changed, 'warning' );
	},

	/**
	 * Hides the message
	 */
	hideMessage: function () {
		this.$el.parent( '.ph-comment-info' ).stop( true ).slideUp( 500 );
	},

	/**
	 * Shows the message
	 *
	 * @param comment {string} Comment Text
	 * @param type {string} Class to add to parent container
	 */
	showMessage: function ( comment, type ) {
		this.$el.html( comment );

		this.$el.parent( '.ph-comment-info' )
			.addClass( type )
			.stop( true )
			.slideDown( 500 );
	}

} );

/**
 * View to show our individual comment item text
 *
 * @since 1.0
 */
Huddle.CommentItemControlsView = Huddle.View.extend({
    template: wp.template('comment-item-controls'),
    className: 'comment-item-controls-inner',

    initialize: function() {
        this.listenTo(this.model, 'change:edit', this.showHide);
    },

    showHide: function() {
        this.$el.toggle(!this.model.get('edit'));
    }
});
/**
 * View to show our individual comment item text
 *
 * @since 1.0
 */
Huddle.CommentItemTextView = Huddle.View.extend({
	template: wp.template('comment-item-text'),
	className: 'comment-item-text',

	triggers: {
		'change:content': 'render',
		'change:edit'   : ['showHide', 'render']
	},

	showHide: function() {
		this.$el.toggle(!this.model.get('edit'));
	}
});
/**
 * View to show our individual comment item
 *
 * @since 1.0
 */
Huddle.CommentItemView = Huddle.View.extend({
	template : wp.template('project-comment-item'),
	className: 'ph-comment-item',

	events: {
		'click .ph-remove': 'removeComment',
		'click .ph-edit'  : 'editComment'
	},

	initialize: function () {
		// avatar if set
		if (this.model.get('author_avatar_urls')) {
			this.views.set('.ph-avatar', new Huddle.AvatarView({
				model: this.model
			}));
		}

		// comment item text view
		this.views.set('.ph-comment-item-text', new Huddle.CommentItemTextView({
			model: this.model
		}));

		// edit comment form
		this.views.set('.ph-edit-textarea', new Huddle.CommentEditFormView({
			model : this.model,
		}));

		// only edit your own
		if (this.model.get('moderate')) {
			this.views.set('.ph-item-controls', new Huddle.CommentItemControlsView({
				model: this.model
			}));
		}
	},

	/**
	 * Remove comment click handler - let the collection handle itself
	 */
	removeComment: function (e) {
		e.preventDefault();
		confirm(PH_Settings.translations.are_you_sure) && this.destroyComment();
	},

	/**
	 * Shows the edit textbox, focuses and places cursor at end
	 */
	editComment: function () {
		this.model.set('edit', true);
	},

	/**
	 * Animate removal
	 */
	destroyComment: function () {
		this.$el.slideToggle(250, _.bind(function () {
			this.remove();
			this.unbind();
			this.model.destroy();
		}, this));
	}
});
/**
 * Comment Panel Items
 */
Huddle.CommentsPanelItemView = Huddle.View.extend( {
	className: 'ph-comment-panel-item',
	template: wp.template( 'panel-item' ),

	events: {
		'click': 'navigateComment'
	},

	navigateComment: function(e) {
		this.model.set({
			'show': true,
			'scroll': true
		});
		e && e.preventDefault();
	}
});
/**
 * Comment Panel View
 */
Huddle.CommentsPanelView = Huddle.View.extend( {
    id: 'ph-comments-panel',
    template: wp.template( 'comments-panel' ),

    events: {
      'click .close-panel': 'close'
    },

    initialize: function() {
        this.listenTo(Huddle.state, 'change:panel', this.openClose);
        this.setComments();
        this.listenTo(this.model.get('threads'), 'update remove', this.setComments);
        this.listenTo(this.model.get('threads'), 'change:scroll', this.close);
    },

    ready: function() {
        this.topBar = jQuery('#top-bar');
        if ( this.topBar.length ) {
			this.$el.css('top', this.topBar.outerHeight());
			this.topBar.find('img').load(_.bind(function () {
				this.$el.css('top', this.topBar.outerHeight());
			}, this));
		}
    },

    /**
     * Show/Hide panel
     * @param state
     */
    openClose: function (state) {
        this.$el.toggleClass('ph-show', state.get('panel'));
    },

    /**
     * Close panel using state
     */
    close: function() {
       Huddle.state.set('panel', false);
       return false;
    },

    /**
     * Add comment views
     * @param state
     */
    setComments: function () {
		var views = [];
		this.model.get('threads').forEach(function (item) {
			views.push(new Huddle.CommentsPanelItemView({
				model: item
			}));
		}, this);
		this.views.set('.ph-comments-container', views);
    }
});
/**
 * View to show our comment button
 *
 * @since 1.0
 */
Huddle.CommentSubmitButtonView = Huddle.View.extend({
	template : wp.template('project-comment-submit-button'),
	className: 'ph-button submit-comment',
	tagName  : 'button',

	events: {
		'click': 'buttonClickHandler'
	},

	/**
	 * Handle Button Click
	 */
	buttonClickHandler: function () {
		this.model.trigger('submit', this.model);
		return false;
	}
});
/**
 * View to show our comment button
 *
 * @since 1.0
 */
Huddle.CommentSubmitControlsView = Huddle.View.extend({
    triggers: {
        'change:controls': 'controlsChangeHandler',
    },

    initialize: function () {
        // submit button view
        this.views.add(new Huddle.CommentSubmitButtonView({
            model: this.model
        }));

        // cancel button view
        this.views.add(new Huddle.CommentCancelButtonView({
            model: this.model
        }));
    },

    ready: function () {
        this.controlsChangeHandler();
    },

    controlsChangeHandler: function () {
        this.$el.toggle(this.model.get('controls'));
    }
});
/**
 * Comment view
 *
 * @since 1.0
 */
Huddle.CommentView = Huddle.View.extend({
	template : wp.template('website-comment'),
	className: 'ph-comment',

    events: {
        'mouseenter'               : 'hoverDot',
        "mouseleave"               : 'unHoverDot',
        'click'                    : 'clickDot',
        'focus .ql-editor'         : 'showComment'
    },

	triggers: {
		'destroy'          : 'remove',
		'change:show'      : 'toggleShow',
		'change:hover'     : 'toggleHover',
		'change:scroll'    : 'scroll',
		'change:x change:y': 'render',
		'dropped'          : ['makeDraggable', 'setLocation', 'relativePosition']
	},

	initialize: function() {
		this.views.add('.ph-comment-thread', new Huddle.CommentDotView({
			model: this.model
		}));

		this.views.add('.ph-comment-thread', new Huddle.CommentBubbleView({
			model: this.model
		}));

		// position and check scroll when image renders
		this.listenTo(Huddle.Event, 'imageRendered', this.sizeEvents);
		this.listenTo(Huddle.Event, 'imageRendered', this.checkScroll);

		// update position and size on zoom change
		this.listenTo(Huddle.Event, 'change:zoom', function(){
			_.defer(_.bind(this.sizeEvents, this));
		});

		_.bindAll(this, 'sizeEvents', 'clickDot', 'makeDraggable');
	},

	ready: function() {
		this.sizeEvents();
	},

    // toggle show/hide comments
    toggleShow: function () {
        this.$el.toggleClass('ph-clicked-dot ph-hover-dot', this.model.get('show'));
    },

	setLocation: function(e, ui) {
		// set or save
		var action = this.model.isNew() ? 'set' : 'save';
		this.model[action]({
			'relativeX': Math.max(0, ui.position.left) / this.$el.closest('.ph-project-image-inner').width(),
			'relativeY': Math.max(0, ui.position.top) / this.$el.closest('.ph-project-image-inner').height()
		}, {patch: true, validate: false});
	},

    // convenience function to show comment
    showComment: function () {
        this.model.set('show', true);
    },

    // Event handler when dot is hovered
    hoverDot: function () {
        clearTimeout(this.hoverTimer);
		this.model.collection.forEach(_.bind(function (model, index) {
			model.set('hover', false);
		}, this));
		this.model.set('hover', true);
    },

    // change hover class
    toggleHover: function () {
        this.$el.toggleClass('ph-hover-dot', this.model.get('hover'));
    },

    // unhover dot, small delay for ux
    unHoverDot: function () {
        this.hoverTimer = _.delay(_.bind(function () {
            this.model.set('hover', false)
        }, this), 750);
    },

    // clicked dot handler
    clickDot: function () {
		this.model.collection.forEach(function (model, index) {
			model && model.set('show', this.model.id === model.id);
		}, this);
    },

	/**
	 * Checks scroll cookie on load
	 */
	checkScroll: function () {
		if (!PH_Settings.comment_scroll) {
			return;
		}
		if (parseInt(PH_Settings.comment_scroll) === this.model.get('id')) {
			this.model.set({
				'show'  : true,
				'scroll': true
			});
			// do ready after image render
			this.model.trigger('change:scroll');

			PH_Settings.comment_scroll = false;
		}
	},

    // Run on resize
    sizeEvents: function () {
        this.relativePosition();
        this.makeDraggable();
    },

    // Place comment relative to parent container
    relativePosition: function () {
        var container = this.$el.closest('.ph-project-image-inner');
        // set x/y coordinates
        this.model.set({
            'x': container.width() * this.model.get('relativeX'),
            'y': container.height() * this.model.get('relativeY')
        });
    },

	// Makes the element draggable to change the location
	makeDraggable: function () {
		_.defer(_(function () { // always defer, just in case UI isn't up to speed
			this.$('.ph-comment-thread').draggable({
				start : this.clickDot,
				delay : 50,
				handle: ".ph-annotation-dot",
				cursor: "move",
				stop  : _.bind(this.stop, this)
			});
		}).bind(this));
	},

    // when dragging stops
    stop: function (e, ui) {
	    this.model.trigger('dropped', e, ui);
    },

	// scroll to comment
	scroll: function () {
		if (this.model.get('scroll') === true) {
			jQuery('.ph-project-image-outer').animate({
				scrollTop: this.model.get('y') - 75
			}, 500);
			this.model.set('scroll', false);
		}
	}
});
/**
 * Control Bar View
 *
 * Subview of the image collection view that shows controls
 */
Huddle.ControlBarView = Huddle.View.extend({
    id: 'top-bar-inner',
    template: wp.template('control-bar'),
    tagName: 'div',

    events: {
        'click .ph-next-trigger': 'nextImage',
        'click .ph-prev-trigger': 'prevImage',
        'click .ph-share-trigger': 'triggerShare',
        'click .ph-login': 'triggerLogin',
        'click .mobile-more': 'mobileMenuClick'
    },

    triggers: {
        'change:mobileMenu': 'toggleMobileMenu',
    },

    animation: {
        hoverTimer: false
    },

    initialize: function () {
        this.model.get('images').length > 1 && this.views.add('.project-nav-controls', new Huddle.PrevNextView({
            model: this.model
        }));
        // image nav controls
		this.model.get('images').length > 1 && this.views.add('.project-controls', new Huddle.ImagesButtonView({
            model: this.model
        }));

        // comments navigator
        this.views.add('.project-controls', new Huddle.CommentsButtonWrapView({
            model: this.model
        }));

        // settings-dropdown
        this.views.add('.project-controls', new Huddle.SettingsDropdownContainerView({
            model: this.model
        }));

        // user dropdown
        this.views.add('.project-controls', new Huddle.UserDropdownView({
            model: this.model
        }));

        // approval button
		this.views.add('.project-controls', new Huddle.ApproveContainerView({
			model: this.model
		}));

        // image tray
        this.views.add('#ph-image-tray-wrap', new Huddle.ImageTrayView({
            model: this.model
        }));

        // show comments
        this.listenTo(Huddle.Event, 'showComments', this.showComments);

        this.listenTo(Huddle.user, 'change:id', this.render);

        // listen to close all global event
        this.listenTo(Huddle.Event, 'closeAll', this.closeThumbDrawer);

        // listen to state change of tray
        this.listenTo(Huddle.state, 'change:tray', this.restoreMobileMenu);

        // broadcast init
        wp.hooks.doAction('Huddle.ControlBarView.initialize', this);
    },

    // mobile menu click handler
    mobileMenuClick: function() {
        this.model.set('mobileMenu', !this.model.get('mobileMenu'));
        return false;
    },

    // toggle mobile menu class
    toggleMobileMenu: function() {
        this.$el.toggleClass('open', this.model.get('mobileMenu'));
    },

    // restore menu when tray is closed
    restoreMobileMenu: function() {
        this.model.set('mobileMenu', !Huddle.state.get('tray'));
    },

    /**
     * Toggles thumb drawer
     */
    closeThumbDrawer: function () {
        Huddle.state.set('tray', false);
    },

    /**
     * Let anyone who's listening know the prev image link was clicked
     *
     * @param e
     */
    prevImage: function (e) {
        e.preventDefault();

        var prev    = false;
        var current = this.model.get('images').get(Huddle.state.get('image'));
        var index   = this.model.get('images').indexOf(current);

        if (index !== 0) {
            prev = this.model.get('images').at(index - 1);
        } else {
            prev = this.model.get('images').at(this.model.get('images').length - 1);
        }

        Huddle.router.navigate(prev.get('slug'), {trigger: true});
    },

    /**
     * Let anyone who's listening know the next image link was clicked
     *
     * @param e
     */
    nextImage: function (e) {
        e.preventDefault();

        var next    = false;
        var current = this.model.get('images').get(Huddle.state.get('image'));
        var index   = this.model.get('images').indexOf(current);

        if ((index + 1) < this.model.get('images').length) {
            next = this.model.get('images').at(index + 1);
        } else {
            next = this.model.get('images').at(0);
        }

        Huddle.router.navigate(next.get('slug'), {trigger: true});
    },

    /**
     * Enable Comments
     */
    showComments: function () {
        var body = jQuery('body');

        if (!body.hasClass('hide-comments')) {
            return;
        }

        this.$('.ph-toggle-comments').removeClass('disabled').find('i').removeClass('ion-eye-disabled');
        body.removeClass('hide-comments');
        Huddle.state.set('hideComments', false);
    },

    /**
     * Trigger share image event
     */
    triggerShare: function () {
        Huddle.Event.trigger('shareImage', this.model.get('images').get(Huddle.state.get('image')));
    },

    /**
     * Trigger login event
     */
    triggerLogin: function () {
        Huddle.Event.trigger('requireLogin', this.model.get('images').get(Huddle.state.get('image')));
    },

    /**
     * Mouse leave handler of thumb drawer
     */
    mouseLeaveThumbDrawer: function () {
        this.animation.hoverTimer = _.delay(_.bind(function () {
            Huddle.state.set('tray', false);
        }, this), 1000);
    },

    /**
     * Mouse enter handler of thumb drawer
     */
    mouseEnterThumbDrawer: function () {
        clearTimeout(this.animation.hoverTimer);
    }
});
/**
 * Comments Button Views
 */
Huddle.CommentsButtonWrapView = Huddle.View.extend({
    className: 'ph-comments-number-wrap',
    tagName: 'span',

    initialize: function () {
        this.listenTo(Huddle.state, 'change:image', this.setView);
    },

    setView: function (state) {
        this.views.set(new Huddle.CommentsButtonView({
            model: this.model.get('images').get(state.get('image'))
        }));
    }
});

/**
 * Comment Button
 */
Huddle.CommentsButtonView = Huddle.View.extend({
    id: 'nav-icon',
    template: wp.template('comments-button'),
    tagName: 'span',

    events: {
        'click': 'togglePanel'
    },

    // re-render when thread count changes
    initialize: function () {
        this.listenTo(this.model.get('threads'), 'update reset', this.render);
    },

    togglePanel: function () {
        Huddle.state.set('panel', !Huddle.state.get('panel'));
        // close tray if panel and tray are open
        Huddle.state.get('tray') && Huddle.state.get('panel') && Huddle.state.set('tray', false);
        return false;
    }
});
/**
 * Image Nav View
 */
Huddle.ImagesButtonView = Huddle.View.extend( {
    id: 'nav-icon',
    template: wp.template( 'images-button' ),
    tagName: 'span',

    events: {
        'click ': 'toggleTray'
    },

    toggleTray: function () {
        Huddle.state.set('tray', !Huddle.state.get('tray'));

        // close tray if panel and tray are open
        if (Huddle.state.get('tray') && Huddle.state.get('panel')) {
            Huddle.state.set('panel', false);
        }
        return false;
    }
});
Huddle.PrevNextView = Huddle.View.extend({
    className: 'ph-prev-next-buttons',
    tagName: 'span',
    template: wp.template('prev-next-buttons')
});
// dropdown container
Huddle.SettingsDropdownContainerView = Huddle.View.extend({
    id: 'nav-icon',
    tagName: 'span',

    initialize: function () {
        this.listenTo(Huddle.state, 'change:image', this.setView);
    },

    /**
     * Adds the approval button with the right image state
     *
     * @param state State model
     */
    setView: function (state) {
        this.views.set(new Huddle.SettingsDropdownView({
            model: this.model.get('images').get(state.get('image'))
        }));
    }
});

// dropdown
Huddle.SettingsDropdownView = Huddle.View.extend({
    id: 'nav-icon',
    template: wp.template('settings-dropdown'),
    tagName: 'span'
});
/**
 * Image Nav View
 */
Huddle.UserDropdownView = Huddle.View.extend({
    id       : 'nav-icon',
    tagName  : 'span',
    className: 'ph-user ph-dropdown hover-trigger',

    initialize: function() {
        this.views.add(new Huddle.LoginAvatarView({
            model: Huddle.me
        }));
        this.views.add(new Huddle.LoginDropDownView({
            model: Huddle.me
        }));

        this.listenTo(Huddle.me, 'change', this.render);
    }
});

Huddle.LoginAvatarView = Huddle.View.extend({
    template : wp.template('login-avatar'),
    className: 'ph-avatar ph-select-text ph-control',
    tagName  : 'span',

    initialize: function () {
        this.listenTo(Huddle.user, 'change', this.render);
    }
});

Huddle.LoginDropDownView = Huddle.View.extend({
    template : wp.template('login-dropdown'),
    className: 'ph-select-dropdown ph-right-align ph-hidden',
    tagName  : 'span',

    events: {
        'click .ph-forget-me': 'forget',
        'click .ph-logout'   : 'logout'
    },

    initialize: function () {
        this.listenTo(Huddle.user, 'change', this.render);
    },

    forget: function () {
        Huddle.user.forget();
    },

    logout: function (e) {
        if ( !Cookies.get('Huddle.user') ) {
            return;
        }
        
        // Remember the link href
        var href = e.target.href;

        // Don't follow the link
        e.preventDefault();

        this.forget();

        window.location = href;
    }
});
/**
 * Copy Link Popup View
 *
 * Subview of the the dialog box that shows the copy link popup
 */
Huddle.CopyDialogView = Huddle.View.extend({

	template: wp.template( 'dialog-copy-link' ),

	events: {
		'click .ph-dialog-cancel': 'closeDialog',
		'click .ph-dialog-submit': 'closeDialog'
	},

	// broadcast init
	initialize: function() {
		// listen to close all global event
		this.listenTo( Huddle.Event, 'closeAll', this.closeDialog );

		wp.hooks.doAction( 'Huddle.CopyDialogView.initialize', this );
	},

	// render dialog box view
	render: function() {

		// cache this
		var base = this;

		// call the base class `render` method and we'll extend it
		wp.Backbone.View.prototype.render.apply(this, arguments);

		// open dialog
		this.dialog = vex.open( {
			content: this.el, // use template content
			afterOpen: function() {
				// trigger open event callback
				autosize( base.$el.find( 'textarea' ) );
				base.$el.find( 'textarea' ).select();
				base.model.trigger( 'dialogOpened', base.model, base );
			},
			afterClose: function () {
				// trigger close event callback
				base.model.trigger( 'dialogClosed', base.model, base );
				// remove view completely
				base.remove();
			}
		});

	},

	/**
	 * When dialog is cancelled
	 */
	closeDialog: function( e ) {

		e.preventDefault();
		e.stopPropagation();

		vex.close( this.dialog.data().vex.id );
		Huddle.Event.trigger( 'dialogClosed', this.model );
	}
} );
/**
 * Controls the various dialog boxes needed for the plugin
 *
 * @since 1.0
 */
Huddle.DialogView = Huddle.View.extend( {

	initialize: function () {

		// listen for need identity dialog in current image comments
		Huddle.Event.on( 'requireIdentity', this.identifyPopup, this );

		// listen for need identity dialog in current image comments
		Huddle.Event.on( 'requireLogin', this.loginPopup, this );

		// listen for need identity dialog in current image comments
		Huddle.Event.on( 'shareImage', this.sharePopup, this );

		// listen for need identity dialog in current image comments
		Huddle.Event.on( 'shareComment', this.shareCommentPopup, this );

		// listen for need identity dialog in current image comments
		Huddle.Event.on( 'copyCommentLink', this.copyCommentLinkPopup, this );

		// broadcast init
		wp.hooks.doAction( 'Huddle.DialogView.initialize', this );
	},

	/**
	 * Create identify popup view and render
	 *
	 * @param model {object} Model to use for popup
	 */
	identifyPopup: function ( model ) {
		new Huddle.IdentifyDialogView( {
			model: model
		} ).render();
	},

	/**
	 * Create login popup view and render
	 *
	 * @param model {object} Model to use for popup
	 * @param backEvent {string} Optional event to call for back button
	 */
	loginPopup: function ( model, backEvent ) {
		new Huddle.LoginDialogView( {
			model: model,
			backEvent: backEvent
		} ).render();
	},

	/**
	 * Create share popup and render
	 */
	sharePopup: function( model ) {

		// current project
		model.set( 'share_link', Huddle.baseURL );

		// create and render view
		new Huddle.ShareDialogView( {
			model: model
		} ).render();
	},

	/**
	 * Create share popup and render
	 *
	 * @param model {object} Model to use for popup
	 */
	shareCommentPopup: function( model ) {
		// share comment on current image
		model.set( 'share_link', Huddle.baseURL + '#' + Huddle.images.get(Huddle.state.get('image')).get('hash') + '/comment/' + model.get('id') );

		// create and render view
		new Huddle.ShareDialogView( {
			model: model
		} ).render();
	},

	/**
	 * Create share popup and render
	 *
	 * @param model {object} Model to use for popup
	 */
	copyCommentLinkPopup: function( model ) {
		// share comment on current image
		model.set( 'share_link', Huddle.baseURL + '#' + Huddle.images.get(Huddle.state.get('image')).get('hash') + '/comment/' + model.get('id') );

		// create and render view
		new Huddle.CopyDialogView( {
			model: model
		} ).render();
	}
} );
/**
 * View to show our comment form
 *
 * @since 1.0
 */
Huddle.CommentFormControlsView = Huddle.View.extend({
	className: 'ph-comment-form-controls',
	template : wp.template('thread-form-controls'),
});
/**
 * Identify Popup View
 *
 * Subview of the the dialog box that shows the identify popup
 */
Huddle.IdentifyDialogView = Huddle.View.extend({
    template: wp.template('dialog-identify'),

    events: {
        'click .vex-dialog-button': 'cancelDialog',
        'click .ph-dialog-login': 'loginDialog',
        'click .ph-dialog-submit': 'submit',

        "keyup input[type='email']": "emailChangeHandler",
        "input input[type='email']": "emailChangeHandler",
        "paste input[type='email']": "emailChangeHandler",
        "change input[type='email']": "emailChangeHandler"
    },

    // broadcast init
    initialize: function () {
        wp.hooks.doAction('Huddle.IdentifyDialogView.initialize', this);
    },

    // render dialog box view
    render: function () {

        // cache this
        var base = this;

        // call the base class `render` method and we'll extend it
        wp.Backbone.View.prototype.render.apply(this, arguments);

        this.submitButton = this.$el.find('button[type="submit"]');
        this.emailInput   = this.$el.find('input[type="email"]');

        // open dialog
        this.dialog = vex.open({
            content: this.el, // use template content
            afterOpen: function ($vexContent) {
                // trigger open event callback
                base.model.trigger('dialogOpened', base.model, base);

                base.submitButton = base.$el.find('button[type="submit"]');
                base.submitButton.attr('disabled', true);
            },
            afterClose: function () {
                // trigger close event callback
                base.model.trigger('dialogClosed', base.model, base);
                // remove view completely
                base.remove();
            }
        });

    },

    cancelDialog: function () {
        vex.close(this.dialog.data().vex.id);
        this.model.trigger('dialogCancelled', this.model);
    },

    loginDialog: function () {
        vex.close(this.dialog.data().vex.id);
        Huddle.Event.trigger('requireLogin', this.model, 'requireIdentity');
    },

    /**
     * Get all form data and convert to array
     *
     * @returns Array of field names with values
     */
    getFormData: function () {

        var arr = this.$el.find('form').serializeArray();

        return _(arr).reduce(function (acc, field) {
            acc[field.name] = field.value;
            return acc;
        }, {});
    },

    isEmail: function (email) {
        var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
        return regex.test(email);
    },

    /**
     * Handle email box change
     *
     * @param e
     */
    emailChangeHandler: function (e) {
        this.checkValidEmail(e.currentTarget.value);
    },

    /**
     * Checks valid email and enables or disables submit button
     *
     * @param $value
     */
    checkValidEmail: function ($value) {
        if (this.isEmail($value)) {
            this.emailInput.removeClass('ph-error');
            this.submitButton.attr('disabled', false);
        } else {
            this.emailInput.addClass('ph-error');
            this.submitButton.attr('disabled', true);
        }

        if (!$value || $value == '') {
            this.emailInput.removeClass('ph-error');
        }
    },

    /**
     * Submit form handler
     * @param e
     */
    submit: function (e) {
        e.preventDefault();
        e.stopPropagation();

        var data = this.getFormData();

        Huddle.user.set({
            'display_name': data.username,
            'user_email': data.email
        });

        Cookies.set('Huddle.user', Huddle.user);

        this.model.trigger('identifySuccess', this.model)
    }
});
Huddle.ImageFilterView = Huddle.View.extend({
	template : wp.template('image-filter'),
	className: 'ph-image-filter-dropdown-container',

	events: {
		'click'   : 'toggle',
		'click li': 'sort'
	},

	triggers: {
		'change:filter': 'render'
	},

	toggle: function () {
		this.$el.toggleClass('ph-show');
	},

	sort: function (e) {
		this.model.set('filter', jQuery(e.target).data('sort'));
	}
});

Huddle.NoImagesView = Huddle.View.extend({
	className: 'ph-none-approved',
	template: wp.template('no-images')
});
/**
 * Control Bar View
 *
 * Subview of the image collection view that shows controls
 */
Huddle.ImageThumbView = Huddle.View.extend({
    className: 'ph-nav-thumb-link',
    template: wp.template('image-thumb'),
    tagName: 'span',

    events: {
        'click': 'navigateImage'
    },

    initialize: function () {
        // when comment count changes, re-render
        this.listenTo(this.model, 'change:image change:approval', this.render);

        // broadcast init
        wp.hooks.doAction('Huddle.ImageThumbView.initialize', this);
    },

    navigateImage: function () {
        Huddle.router.navigate(this.model.get('slug'), {trigger: true});
    }
});
Huddle.ImageTrayView = Huddle.View.extend({
    id      : 'ph-thumbs-navigator',
    template: wp.template('image-tray'),

    events: {
        'click .ph-toggle-nav': 'closeTray'
    },

    initialize: function () {
        // comment items
        _.each(this.model.get('images').models, function (image) {
            this.views.add('#ph-thumb-nav-inner', new Huddle.ImageThumbView({
                model: image
            }));
        }, this);

		// add filter view
		this.views.add('.ph-filter', new Huddle.ImageFilterView({
			model: this.model
		}));

		this.listenTo(this.model, 'change:filter', this.filter);
		this.listenTo(this.model.get('images'), 'change:approval', this.filter);

        this.listenTo(Huddle.state, 'change:tray', this.showHideTray);

        // broadcast init
        wp.hooks.doAction('Huddle.ImageTrayView.initialize', this);
    },

	filter: function () {
		this.images = [];
		this['filter' + _(this.model.get('filter')).capitalize()]();
		this.setImages();
	},

	setImages: function () {
		if (this.images.length) {
			this.views.set('#ph-thumb-nav-inner', this.images);
		} else {
			console.log('none');
			this.views.set('#ph-thumb-nav-inner', new Huddle.NoImagesView({
				model: this.model
			}))
		}
	},


	filterApproved: function () {
		_.each(this.model.get('images').where({approval: true}), function (image) {
			this.images.push(new Huddle.ImageThumbView({
				model: image
			}));
		}, this);
	},

	filterUnapproved: function () {
		_.each(this.model.get('images').where({approval: false}), function (image) {
			this.images.push(new Huddle.ImageThumbView({
				model: image
			}));
		}, this);
	},

	filterAll: function () {
		_.each(this.model.get('images').models, function (image) {
			this.images.push(new Huddle.ImageThumbView({
				model: image
			}));
		}, this);
	},

    closeTray: function () {
        Huddle.state.set('tray', false);
    },

    showHideTray: function (state) {
        this.$el.toggleClass('ph-show', state.get('tray'));
    }
});
/**
 * View to show our individual image
 * Creates models and views for new comments
 *
 * @since 1.0
 */

Huddle.ImageView = Huddle.View.extend({
    template: wp.template('project-image'),
    className: 'ph-project-image-outer',

    events: {
        "click img.ph-project-image"    : 'clicked',
        'touchstart img.ph-project-image, touchmove img.ph-project-image, touchend img.ph-project-image': 'touchTool',
        "mouseenter img.ph-project-image": "hideTray",
        "mouseleave img.ph-project-image": "resetTray"
    },

    options : {},

    /**
     * Set templates and listen for model events
     */
    initialize: function () {
		// store image view options
        this.options = this.model.get('options');
        this.model.get('threads').forEach(this.setAnnotation, this);

        this.views.add('.ph-image-controls', new Huddle.ImageZoomView({
            model: this.model
        }));

        // when a new model is added to the collection, render it
        this.listenTo(this.model.get('threads'), 'add', this.renderComment);
        this.listenTo(this.model.get('threads'), 'add', this.maybeMobileScroll);

        // zoom events
        this.listenTo(this.model, 'change:zoom', this.zoom);
        this.model.set('magnification', 1);

        // if comments aren't allowed
        if ( ! Huddle.permissions.get('allowComments') ) {
            this.$('img.ph-project-image').off();
        }

        jQuery(window).resize(_.bind(this.setScroll, this));

        // broadcast init
        wp.hooks.doAction('Huddle.ImageView.initialize', this);
    },

    /**
     * Delegate events when ready
     */
    ready: function () {
        this.loadImage();
    },

    loadImage: function() {
        // hide
        this.$el.css('opacity', 0);

        var image = this.$('img.ph-project-image');

        // get the image src so it can be put back in to convince IE to run the .load() function correctly
        var imgSrc = image.attr("src");

        if ( ! image.prop('complete') ) {
            this.$('img.ph-project-image').on('load',
                _.bind(function(){
                    this.setImage();
                    this.fadeImage();
					Huddle.Event.trigger('imageRendered');
                }, this)
            ).attr("src", imgSrc); //makes .load() work in IE when images are cached
        } else {
            this.setImage();
            this.$el.css('opacity', 1);
        }
    },

    zoom: function() {
        var w     = jQuery(window),
            image = this.$('img.ph-project-image');

        // find center of image on screen from left/top in px
        var offsetLeft = this.$el.scrollLeft() + (w.width()/2);
        var offsetTop = this.$el.scrollTop() + (w.height()/2);

        // get percentage of image to center
        var percentageCenterX = offsetLeft / this.el.scrollWidth;
        var percentageCenterY = offsetTop / this.el.scrollHeight;

        if (this.model.get('zoom') === 'in') {
            image.width(image.width() * this.model.get('zoomAmount'));
        } else {
            image.width(image.width() / this.model.get('zoomAmount'));
        }

        // override fixed scale class if zoomed in
        if ( this.options.ph_image_size === 'scale' ) {
            image.toggleClass('scale-override', this.model.get('magnification') > 1);
            if ( this.model.get('magnification') === 1 ) {
                image.css('width', '');
            }
        }

        jQuery(window).trigger('resize'); // trigger position of comments

        this.$el.scrollLeft(percentageCenterX * this.el.scrollWidth - (w.width()/2));
        this.$el.scrollTop(percentageCenterY * this.el.scrollHeight - (w.height()/2));
    },

    maybeMobileScroll: function (model) {
        Huddle.window.width() <= 780 && model.set('scroll', true);
    },

    /**
     * Gets image options and displays image properly
     */
    imageOptions: function () {
        // expect options
        if (!this.options) return;

        // image alignment
        if (this.options.ph_image_alignment) {
            this.$el.addClass('ph-alignment-' + this.options.ph_image_alignment);
        }

        // size/zoom behavior class
        this.options.ph_image_size && this.$el.addClass('ph-size-' + this.options.ph_image_size);

        // background-color
        this.options.ph_image_background_color && this.$el.css('background-color', this.options.ph_image_background_color);

        // background image
        this.options.ph_image_background_image && this.$el.css('background-image', 'url(' + this.options.ph_image_background_image + ')');

        // background image position
        if (this.options.ph_image_background_image_position) {

            // center image no matter what
            this.$el.css('background-position', 'top center');

            switch (this.options.ph_image_background_image_position) {
                case 'center':
                    this.$el.css('background-repeat', 'no-repeat');
                    break;
                case 'repeat':
                    this.$el.css('background-repeat', 'repeat');
                    break;
                case 'repeat-x':
                    this.$el.css('background-repeat', 'repeat-x');
                    break;
                case 'cover':
                    this.$el.css('background-size', 'cover');
                    this.$el.css('-webkit-background-size', 'cover');
                    this.$el.css('-mox-background-size', 'cover');
                    this.$el.css('-ms-background-size', 'cover');
                    break;
            }
        }

        this.setScroll();
    },

    setScroll: function () {
		if (!this.options.ph_image_alignment) {
			return;
		}

		// center on scroll
		if (this.options.ph_image_alignment == 'center') {
			var containerWidth = jQuery(window).width(),
			    image = new Image(),
                thisWidth;

			// get natural image width
			image.src = this.$el.find('img.ph-project-image').attr("src");
			thisWidth = image.naturalWidth;

			// half for retina
			if ( 'on' === this.model.get('retina') ) {
			    thisWidth = thisWidth /2;
            }

			var difference = thisWidth < containerWidth ? (containerWidth - thisWidth ) / 2 : -(containerWidth - thisWidth ) / 2;
			this.$el.scrollLeft(difference);
		}
		if (this.options.ph_image_alignment == 'right') {
			this.$el.scrollLeft(this.$el.width());
		}
    },

    /**
     * Scrolltop, fade in image
     */
    setImage: function ( fade ) {
        // set retina option
        this.setRetina();

        // set image display options
        this.imageOptions();

        // add scrollbar, scroll to top
        this.$el.scrollTop();

        this.originalWidth = this.$('img.ph-project-image').width();

        // trigger render
        Huddle.Event.trigger('imageRender');
    },

    fadeImage: function() {
        this.$el.animate({'opacity': 1}, 250, function () {
            Huddle.Event.trigger('imageRendered');
        });
    },

    /**
     * Retina specific css
     */
    setRetina: function () {
        if ('on' == this.model.attributes.retina) {
            var thisImage = this.$('.ph-project-image');
            var thisWidth = thisImage.width();

            thisImage.css({
                'width': thisWidth / 2,
                'height': 'auto'
            });
        }
    },

    /**
     * Load existing annotation dots
     *
     * @param comment Model to use for the comment view
     */
    setAnnotation: function (comment) {
        // create a new subview for each comment
        this.views.add('.ph-image-comments-container', new Huddle.CommentView({
            model: comment,
            parent: this
        }));
    },

    /**
     * Handler to check what happens when the image is clicked
     *
     * @param e Click event
     */
    clicked: function (e) {
        // ignore right and middle click
        if (e && ( e.which == 2 || e.which == 3 )) return false;

        // only if comments are allowed
        // if (!Huddle.permissions.get('allowComments')) {
        //     toastr.error(Huddle.translations.login_required);
        //     return false;
        // }

        // hide all others
        this.model.get('threads').invoke('set', {show: false});

        // check bubble
        // if (this.bubbleCheck(e, _.bind(this.annotateImage, this)) == false) {
        //     return false;
        // }

		// var newComment = this.model.get('threads').find(_.bind(function (model) {
		// 	return model.isNew();
		// }, this));

        Huddle.state.set({
            'tray': false,
            'panel': false
        });

        // annotate image
        this.annotateImage(e);

        // prevent default click functionality
        e.stopPropagation();
        return false;
    },

    /**
     * Checks existing bubbles before callback
     *
     * @param options Callback options
     * @param callback Callback Function
     * @returns {boolean} Continue with parent function
     */
    // bubbleCheck: function (options, callback) {
    //     // get any new comments
    //     var newComment = this.model.get('threads').find(_.bind(function (model) {
    //         return model.isNew();
    //     }, this));
	//
    //     // remove new comment
    //     if (newComment) {
	//
    //         // confirm dialog if new comment text is entered
    //         if (newComment.attributes.newCommentText) {
    //             this.discardConfirm(newComment, options, callback);
    //             // don't annotate
    //             return false;
    //         }
	//
    //         newComment.set('show', false);
    //         // newComment.collection.remove(newComment);
    //         // this.model.get('threads').remove(newComment);
	//
    //         // continue annotation
    //         return true;
    //     }
    // },

    // discardConfirm: function (commentModel, options, callback) {
    //     vex.dialog.confirm({
    //         message: Huddle.translations.discard ? Huddle.translations.discard : 'Discard your comment?',
    //         callback: _.bind(function (value) {
    //             if (!value) return false;
	//
    //             // remove comment
    //             this.model.get('comments').remove(commentModel);
	//
    //             // callback function
    //             callback && callback(options);
	//
    //             // don't annotate
    //             return false;
    //         }, this)
    //     });
    // },

    /**
     * Annotates Image
     *
     * @param e event object
     * @param xpos (optional) X coordinate to programatically add x position
     * @param ypos (optional) Y coordinate to programatically add y position
     */
    annotateImage: function (e, xpos, ypos) {
        // if click event, calculate offsets
        if (typeof e != 'undefined' && e) {
            if (typeof xpos == 'undefined' || typeof ypos == 'undefined') {
                xpos = e.pageX - jQuery(e.currentTarget).offset().left;
                ypos = e.pageY - jQuery(e.currentTarget).offset().top;
            }
        }

        // add comment model to collection
        this.model.get('threads').add(new Huddle.Comment({
            parent_id: this.model.id,
            relativeX: parseFloat(this.relativeX(e.offsetX)), // store right relative position
            relativeY: parseFloat(this.relativeY(e.offsetY)), // store relative top position
            show: true,
            focus: true
        }));
    },

    /**
     * add comment view to subviews
     */
    renderComment: function (comment) {
        this.views.add('.ph-image-comments-container', new Huddle.CommentView({
            model: comment
        }));
    },

    /**
     * Gets relative x position depending on parent width
     */
    relativeX: function (posLeft) {
        var width = this.$('.ph-project-image-inner').width();
        return posLeft / width;
    },

    /**
     * Gets relative y position depending on parent width
     */
    relativeY: function (posTop) {
        var height = this.$('.ph-project-image-inner').height();
        return posTop / height;
    },

    hideTray: function() {
        this.hoverTimer = _.delay(_.bind(function () {
            Huddle.state.set('tray', false);
        }, this), 350);
    },

    resetTray: function() {
        clearTimeout(this.hoverTimer);
    }
});
Huddle.ImageZoomView = Huddle.View.extend({
    className: 'ph-project-zoom-wrap',
    initialize: function () {
        // subviews
        this.views.add(new Huddle.ZoomPercentView({
            model: this.model
        }));
        this.views.add(new Huddle.ZoomView({
            model: this.model
        }));
    },
    ready: function () {
       // Huddle.options.project.zoom === 'off' && this.$el.addClass('ph-hidden'); // hide if turned off
    }
});

Huddle.ZoomView = Huddle.View.extend({
    template: wp.template('image-zoom-controls'),
    className: 'ph-zoom-controls',
    events: {
        'click .ph-zoom-in': 'zoomIn',
        'click .ph-zoom-out': 'zoomOut'
    },
    ready: function () {
        this.$('.ph-zoom-in, .ph-zoom-out').nodoubletapzoom();
    },
    zoomIn: function () {
        this.model.set({'zoom': 'in'}, {silent: true}).trigger('change:zoom', this.model);
    },
    zoomOut: function () {
        this.model.set({'zoom': 'out'}, {silent: true}).trigger('change:zoom', this.model);
    }
});

Huddle.ZoomPercentView = Huddle.View.extend({
    template: wp.template('image-zoom-percent'),
    className: 'ph-zoom-percent',
    initialize: function () {
        this.listenTo(this.model, 'change:zoom', this.render);
    }
});
/**
 * Login Dialog View
 *
 * Subview of the the dialog box that shows the dialog popup
 */
Huddle.LoginDialogView = Huddle.View.extend({
    template: wp.template('dialog-login'),

    events: {
        'click .ph-dialog-cancel': 'cancelDialog',
        'click .ph-dialog-submit:enabled': 'loginUser'
    },

    // broadcast init
    initialize: function () {
        wp.hooks.doAction('Huddle.LoginDialogView.initialize', this);
    },

    // render dialog box view
    render: function () {
        // call the base class `render` method and we'll extend it
        wp.Backbone.View.prototype.render.apply(this, arguments);

        // open dialog
        this.dialog = vex.open({
            // use template content
            content: this.el,
            overlayClosesOnClick: false,
            afterOpen: _.bind(function () {
                this.model.trigger('dialogOpened', this.model, this);
            }, this),
            afterClose: _.bind(function () {
                this.model.trigger('dialogClosed', this.model, this);
                this.remove();
            }, this)
        });
    },

    /**
     * When dialog is cancelled
     */
    cancelDialog: function () {
        // trigger back event if it exists
        this.options.backEvent && Huddle.Event.trigger(this.options.backEvent, this.model);

        // close dialog
        vex.close(this.dialog.data().vex.id);

        // trigger dialog cancelled
        Huddle.Event.trigger('dialogCancelled', this.model);
    },

    /**
     * Get all form data and convert to array
     *
     * @returns Array of field names with values
     */
    getFormData: function () {
        var arr = this.$el.find('form').serializeArray();

        return _(arr).reduce(function (acc, field) {
            acc[field.name] = field.value;
            return acc;
        }, {});
    },

    /**
     * Sets username and password, runs login function
     */
    loginUser: function (e) {
        // prevent defaults
        e.preventDefault();
        e.stopPropagation();

        var data = this.getFormData();

        Huddle.user.save({
            'username': data.username,
            'password': data.password
        }, {
            wait: true,
            url: Huddle.user.urlRoot + '/login',
            success: _.bind(function() {
                Huddle.state.set({
                    'comment': this.model.get('id'),
                    'commentText': this.model.get('comment_content'),
                    'x': this.model.get('x'),
                    'y': this.model.get('y')
                });
                localStorage.setItem( 'ph_state', JSON.stringify(Huddle.state) );
                Huddle.Event.trigger( 'loginSuccess' );
            }, this)
        });
    }
});
/**
 * Top level view that orchestrates the front-end experience.
 *
 * Extends Huddle.View mixin
 *
 * this.model holds the entire images collection and all subdata
 *
 * @since 1.0
 */
Huddle.ProjectHuddleView = Huddle.View.extend({
    className: "project-huddle-inner",
    template: wp.template('project-image-collection'),

    events: {
        "mousemove": "toolTrack",
        'mouseenter .ph-dropdown.hover-trigger': 'hoverMenu',
        'mouseleave .ph-dropdown.hover-trigger': 'unHoverMenu',
        'click .ph-dropdown.click-trigger': 'toggleSelectMenu'
    },

    initialize: function () {
        // set control bar
        this.views.set('#top-bar', new Huddle.ControlBarView({
            model: this.model
        }));

        // when image state changes, render it
        this.listenTo(Huddle.state, 'change:image', this.setImage);
        this.listenTo(Huddle.state, 'change:image', this.showLoading);
		this.listenTo(Huddle.state, 'change:image', this.commentsPanelView);
        this.listenTo(Huddle.Event, 'imageRendered', this.hideLoading);

        // broadcast init
        wp.hooks.doAction('Huddle.ProjectHuddleView.initialize', this);
    },

    ready: function () {
        // add tooltip
        this.tooltip = jQuery('.ph-image-tip');
    },

    commentsPanelView: function() {
		// add side panel
		this.views.set('.ph-side-panel', new Huddle.CommentsPanelView({
			model: this.model.get('images').get(Huddle.state.get('image'))
		}));
    },

    /**
     * Make tooltip track mouse pointer
     *
     * @param {event} e Event object
     */
    toolTrack: function (e) {
        if ( e.target.className == 'ph-project-image' ) {
            this.displayTool();
            this.tooltip && this.tooltip.css({
                left: e.pageX + 'px',
                top: e.pageY + 'px'
            });
        } else {
            this.hideTool();
        }
    },

    /**
     * Shows tooltips
     */
    displayTool: function (e) {
        this.tooltip && this.tooltip.stop().fadeIn(100);
    },

    touchTool: function() {
        this.$el.off('mousemove');
        this.resetTool();
    },

    hideTool: function () {
        this.tooltip && this.tooltip.stop().fadeOut(100);
    },

    resetTool: function() {
        this.tooltip && this.tooltip.css({
            'top': '-99999px',
            'left': '-99999px'
        });
    },

    // dropdownPosition: function() {
    //     jQuery('.ph-select-dropdown').each(function () {
    //         var left = jQuery(this).offset().left;
    //         if (left < 0) {
    //             jQuery(this).css('margin-right', -Math.abs(left));
    //         }
    //     });
    // },

    hideLoading: function() {
        this.$('.ph-loading').hide();
    },

    showLoading: function() {
        this.$('.ph-loading').show();
    },

    /**
     * Sets the correct image on the canvas when the state changes
     *
     * @param state State model
     */
    setImage: function (state) {
        this.views.set('#canvas', new Huddle.ImageView({
            model: this.model.get('images').get(state.get('image'))
        }));
    },

    /**
     * Store animation classes
     */
    animation: {
        hoverTimer: false
    },

    /**
     * Event handler when menu is hovered
     *
     * @param e Event
     */
    hoverMenu: function (e) {
        clearTimeout(this.animation.hoverTimer);
        jQuery('.ph-select-dropdown').stop().fadeOut(150);
        jQuery(e.currentTarget).find('.ph-select-dropdown').stop().fadeIn(150);
    },

    /**
     * Event handler when menu is unhovered
     *
     * @param e Event
     */
    unHoverMenu: function (e) {
        this.animation.hoverTimer = setTimeout(function () {
            jQuery(e.currentTarget).find('.ph-select-dropdown').stop().fadeOut(150);
        }, 500);
    }
});
/**
 * Share Popup View
 *
 * Subview of the the dialog box that shows the identify popup
 */
Huddle.ShareDialogView = Huddle.View.extend({

	template: wp.template( 'dialog-share' ),

	events: {
		'click .ph-dialog-cancel': 'closeDialog',
		'click .ph-dialog-submit:enabled': 'shareImage',
		"focus .ph-share-message": "elastic"
	},

	ui: {
		textAreaHeight: false
	},

	initialize: function() {
		// close dialog on success
		this.listenTo(this.model, 'sync', this.closeDialog );

		// broadcast init
		wp.hooks.doAction( 'Huddle.ShareDialogView.initialize', this );
	},

	// render dialog box view
	render: function() {
		// cache this
		var base = this;

		// call the base class `render` method and we'll extend it
		wp.Backbone.View.prototype.render.apply(this, arguments);
		//
		// if ( !Huddle.permissions.get('allowComments')) {
		// 	toastr.error(Huddle.translations.no_permission);
		// 	return false;
		// }
		//
		// // check user identity
		// if ( ! Huddle.user.attributes.user_email ) {
		// 	// trigger identity requirement
		// 	Huddle.Event.trigger( 'requireIdentity', this.model );
		// 	return false;
		// }

		// open dialog
		this.dialog = vex.open( {
			className: 'vex-theme-default',
			content: this.el, // use template content
			afterOpen: function() {
				// trigger open event callback
				base.model && base.model.trigger( 'dialogOpened', base.model, base );
			},
			afterClose: function () {
				// trigger close event callback
				base.model && base.model.trigger( 'dialogClosed', base.model, base );
				// remove view completely
				base.remove();
			},
			escapeButtonCloses: false,
			overlayClosesOnClick: false
		});
	},

	/**
	 * When dialog is cancelled
	 */
	closeDialog: function() {
		vex.close( this.dialog.data().vex.id );
		Huddle.Event.trigger( 'dialogClosed', this.model );
	},

	getFormData: function() {
		var arr = this.$el.find('form').serializeArray();
		var data = _(arr).reduce(function(acc, field) {
			acc[field.name] = field.value;
			return acc;
		}, {});

		return data;
	},

	/**
	 * Elasicizes textarea
	 */
	elastic: function( e ){
		autosize( e.currentTarget );
	},

	/**
	 * Sets username and password, runs login function
	 */
	shareImage: function( e ) {
		e.preventDefault();
		e.stopPropagation();


		var data = this.getFormData();

		// check honeypot
		if ( data.website != 0 ) {
			return false;
		}

		// add user to data
		data.user = Huddle.user ? Huddle.user : false;

		// add share link
		if ( this.model.attributes.share_link ) {
			data.link = this.model.attributes.share_link;
		} else {
			data.link = Huddle.baseURL;
		}

        this.model.save({
            'email'     : data,
            'project_id': Huddle.projectID,
            'image_id'  : Huddle.state.get('image'),
            'user'      : Huddle.user
        }, {
            url: Huddle.apiURL + 'mockup/image/' + this.model.get('id') + '/actions/share',
            patch: true,
			success: _.bind(function() {
            	toastr.success(Huddle.translations.email_sent ? Huddle.translations.email_sent : 'Email sent!');
			}, this)
        });
	}
} );
/**
 * Router that controls routes for the project front end
 *
 * @since 1.0.0
 */
Huddle.ProjectRouter = Backbone.Router.extend({

    routes: {
        "": "noHash",
        ":hashID(/)(comment)(/)(:commentid)(/)(comment-text)(/)(:commentText)(/)(x)(/)(:xCoord)(/)(y)(/)(:yCoord)(/)": "imageRoute",
        "#": 'noHash'
    },

    // fired before every route
    execute: function (callback, args) {
        this.trigger('beforeRoute');
        if (callback) callback.apply(this, args);
        this.trigger('afterRoute');
    },

    /**
     * On successful login
     */
    initialize: function () {
        // when person is properly logged in, reload to get new nonces
        Huddle.Event.on('loginSuccess', this.loginReload);

        // update the url when requested with current state information
        Huddle.Event.on('updateStateURL', this.updateStateURL);

        // reset url when requested
        Huddle.Event.on('resetURL', this.resetURL);

        // broadcast init
        wp.hooks.doAction('Huddle.ProjectRouter.initialize', this);
    },

    /**
     * Reload page on successful login
     */
    loginReload: function () {
        window.onbeforeunload = null;
        window.location.reload();
    },

    /**
     * If nothing found, go to error 404
     */
    sessionExpired: function () {
        var noImagesString = Huddle.translations.session_expired ? Huddle.translations.session_expired : 'Your session expired. Please reload the page.';
        // swap out new view
        Huddle.container.$('#canvas').html('<div class="ph-no-images">' + noImagesString + '</div>');
        Huddle.container.$('.ph-loading').remove();
    },

    /**
     * Go to first image if no hash is entered
     */
    noHash: function () {
        if ( ! Huddle.project.get('images').length ) {
			this.noImages();
        }

		this.navigate(Huddle.project.get('images').first().get('slug'), {trigger: true});
    },

    /**
     * If nothing found, go to error 404
     */
    notFound: function () {
        var noImagesString = Huddle.translations.image_not_found ? Huddle.translations.image_not_found : 'Image doesn\'t exist or cannot be found.';
        // swap out new view
        Huddle.container.$('#canvas').html('<div class="ph-no-images">' + noImagesString + '</div>');
        Huddle.container.$('.ph-loading').remove();
    },

	/**
     * No images in project
	 */
	noImages: function () {
        var noImagesString = Huddle.translations.no_images ? Huddle.translations.no_images : 'No images found.';

        // notify
        Huddle.container.$('#canvas').html('<div class="ph-no-images">' + noImagesString + '</div>');
        Huddle.container.$('.ph-loading').remove();
    },

    /**
     * Loads image view into collection based on index
     *
     * @param hashID {string} Index of view in collection
     * @param commentid {mixed} ID of comment or string for new
     * @param commentText {string} Comment Text
     * @param xCoord {int} X coordinate of comment
     * @param yCoord {int} Y coordinate of comment
     */
    imageRoute: function (hashID, commentid, commentText, xCoord, yCoord) {
        // get state from localstorage if it exists
        var local = JSON.parse(localStorage.getItem( 'ph_state' ));
        if ( local ) {
            Huddle.state.set({
                'comment': local.comment,
                'commentText': local.commentText,
                'image': local.image,
                'x': local.x,
                'y': local.y
            });
            localStorage.removeItem('ph_state');
            return;
        }

        // get image model by hash
        var image = Huddle.project.get('images').find(function (model) {
            return model.get('slug') == hashID;
        });

        // check if it exists, if not, notFound
        if (typeof image == 'undefined') {
            this.notFound();
            return false;
        }

        if ( ! image.get('url') ) {
			image.getFeaturedMedia().done(function (media) {
				image.set('image', media);
				// set states
				Huddle.state.set({
					'image': image.get('id'),
					'comment': parseInt(commentid),
					'commentText': commentText ? commentText : false,
					'x': xCoord ? xCoord : false,
					'y': yCoord ? yCoord : false
				});
			});

			return;
		}

        // set states
        Huddle.state.set({
            'image': image.get('id'),
            'comment': parseInt(commentid),
            'commentText': commentText ? commentText : false,
            'x': xCoord ? xCoord : false,
            'y': yCoord ? yCoord : false
        });
    },

    /**
     * Updates the url based on the state
     */
    updateStateURL: function () {
        var state = Huddle.state,
            image = Huddle.images.get(state.get('image')),
            url   = [
                image.get('slug') ? image.get('slug'): '',
                state.get('comment') ? '/comment/' + state.get('comment') : '',
                state.get('commentText') ? '/comment-text/' + state.get('commentText') : '',
                state.get('x') ? '/x/' + state.get('x') : '',
                state.get('y') ? '/y/' + state.get('y') : ''
            ];

        Huddle.router.navigate(encodeURI(url.join("")), {replace: true});
    },

    /**
     * Clear url to current image only
     */
    resetURL: function () {
        Huddle.router.navigate('', {replace: true});
    }
});
/**
 * Setup page events and collections
 *
 * @package     ProjectHuddle
 * @subpackage  js
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */

(function($){

    var isIOS = /iphone|ipad/i.test(navigator.userAgent);
    $.fn.nodoubletapzoom = function () {
        if (isIOS) {
            $(this).bind('touchstart', function preventZoom(e) {
                var t2      = e.timeStamp,
                    t1      = $(this).data('lastTouch') || t2,
                    dt      = t2 - t1,
                    fingers = e.originalEvent.touches.length;

                $(this).data('lastTouch', t2);

                // not double-tap
                if (!dt || dt > 500 || fingers > 1) {
                    return;
                }

                e.preventDefault(); // double tap - prevent the zoom
                // also synthesize click events we just swallowed up
                $(this).trigger('click').trigger('click');
            });
        }
    };

    /**
     * Setup Page
     *
     * @since 1.0
     */
    $(document).ready(function(){

        toastr.options = {
            "closeButton": true,
            "debug": false,
            "newestOnTop": true,
            "progressBar": true,
            "positionClass": "toast-bottom-right",
            "onclick": null,
            "showDuration": "300",
            "hideDuration": "1000",
            "timeOut": "5000",
            "extendedTimeOut": "1000",
            "showEasing": "swing",
            "hideEasing": "linear",
            "showMethod": "fadeIn",
            "hideMethod": "fadeOut"
        };

        // set vex theme
	    vex.defaultOptions.className = 'vex-theme-dialog';

        // page exit confirmation
	    Huddle.confirmOnPageExit = function ( e ) {
		    // If we haven't been passed the event get the window.event
		    e = e || window.event;

		    var message = Huddle.translations && Huddle.translations.unsaved_changes
                ? Huddle.translations.unsaved_changes
                : 'It looks like there are unsaved changes on this project.';

		    // For IE6-8 and Firefox prior to version 4
		    if ( e ) {
			    e.returnValue = message;
		    }

		    // For Chrome, Safari, IE8+ and Opera 12+
		    return e.returnValue;
	    };

        $.extend($.easing,
            {
                easeOutCubic: function (x, t, b, c, d) {
                    return c*((t=t/d-1)*t*t + 1) + b;
                }
            }
        );

    });

    $(window).load(function() {
        $('[data-tip]').tipr({
            'speed': 300
        });
    });

    FastClick.attach(document.body);
}(jQuery));