<!-- Underscore Template -->
<script type="text/template" id="tmpl-project-collection">

	<div class="ph-permalink"></div>

	<div class="ph-update-notice">
		<div class="ph-update-notice-inner">
			<?php _e( 'Your project changed. You should update or save it!', 'project-huddle' ); ?>
		</div>
	</div>

	<!-- main gallery div -->
	<div class="ph-gallery-main">

		<div class="spinner"></div>

		<!-- show gallery attachments -->
		<div id="ph-gallery-attachments">
			<span id="ph-gallery-indicator"></span>
			<a href="#" class="ph-add-image" id="ph-button-add-media"
			   data-uploader-title="<?php _e('Add Project Images', 'project-huddle'); ?>"
			   data-uploader-button-text="<?php _e('Add Images', 'project-huddle'); ?>">
				<span class="ph-icon ion-plus-circled"></span> <?php _e('Add Images', 'project-huddle'); ?>
			</a>
		</div>
		<div class="clear"></div>

	</div><!-- ph-gallery-main -->

</script>
<!-- Underscore Template -->

<!-- Create Initial Collection -->
<script>
	jQuery(document).ready(function(){
		Huddle.start( <?php echo json_encode( $project_data ); ?> );
	});
</script>
