<?php
/**
 * The Template for displaying the panel show comments for the image
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/panel/comment-panel.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     3.0.0
 */
?>

<script type="text/template" id="tmpl-comments-panel">
	<i class="close-panel close-panel-icon">
        <svg xmlns="http://www.w3.org/2000/svg" width="14" height="14" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-x"><line x1="18" y1="6" x2="6" y2="18"></line><line x1="6" y1="6" x2="18" y2="18"></line></svg>
    </i>

	<div class="ph-panel-subheading"></div>
	<div class="ph-comments-container"></div>
</script>
<!-- Comments Panel -->