<?php
/**
 * The Template for displaying the panel show resolved control
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/panel/resolved-toggle.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     3.0.0
 */
?>

<script type="text/html" id="tmpl-ph-panel-resolved-toggle">
    <span class="ph-resolved-label"><?php _e('Show Resolved', 'project-huddle'); ?></span>
    <# if (data.show_resolved) { #>
        <i class="checkbox-outline">
            <svg viewBox="0 0 512 512" id="checkbox" width="10" height="10"><path d="M405.333 64H106.667C83.198 64 64 83.198 64 106.667v298.666C64 428.802 83.198 448 106.667 448h298.666C428.802 448 448 428.802 448 405.333V106.667C448 83.198 428.802 64 405.333 64zm-192 298.667L106.667 256l29.864-29.864 76.802 76.802 162.136-162.136 29.864 29.865-192 192z"></path></svg>
        </i>
    <# } else { #>
        <i class="checkbox-outline-blank">
            <svg viewBox="0 0 512 512" id="checkbox-outline-blank" width="10" height="10"><path d="M405.333 106.667v298.666H106.667V106.667h298.666m0-42.667H106.667C83.198 64 64 83.198 64 106.667v298.666C64 428.802 83.198 448 106.667 448h298.666C428.802 448 448 428.802 448 405.333V106.667C448 83.198 428.802 64 405.333 64z"></path></svg>
        </i>
    <# }  #>
</script>
