<?php
/**
 * The Template for displaying the website thread browser tech detail
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/thread/thread-tech-detail-browser.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     2.7.6
 */
?>

<script type="text/html" id="tmpl-ph-detail-browser">
	<i class="icon-code">
        <svg xmlns="http://www.w3.org/2000/svg" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-code"><polyline points="16 18 22 12 16 6"></polyline><polyline points="8 6 2 12 8 18"></polyline></svg>
	</i>
	{{ data.browser }} {{ data.browserVersion }}
</script>