<?php
/**
 * The Template for displaying the website comment
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/admin/website/website-comment.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     3.0.0
 */
?>

<script type="text/template" id="tmpl-info-comment-item">
	<# if ( data.author_avatar_urls ) { #>
		<div class="ph-avatar">
			<img src="{{{ data.author_avatar_urls[96] }}}" class="avatar" />
		</div>
	<# } #>

	<span class="ph-info-wrapper">
		<span class="ph-item-controls"></span>

		<span class="ph-info">
			<span class="ph-comment-author">
				{{ data.author_name }}
			</span>

			<span class="ph-comment-date">
				{{ data.humanDate }}
			</span>
		</span>
		<span class="ph-comment-item-text ph-comment-content-single"></span>
		<span class="ph-edit-textarea"></span>
	</span>
</script>