<?php
/**
 * The Template for displaying the website page title
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/admin/website/website-page-title.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     3.0.0
 */
?>

<script type="text/html" id="tmpl-webpage-title">
	<span class="ph-website-title-rendered title-link">
		{{{ data.title.rendered }}}
		<span class="ion-edit ph-edit-title"></span>
		<a href="{{{ data.page_url }}}" target="_blank">
			<span class="ion-location"></span>
		</a>
		<span class="ion-trash-a ph-trash-page"></span>
	</span>
	<div class="ph-website-title-edit"></div>
</script>
