<?php
/**
 * The Template for displaying the resolve checkbox
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/admin/website/website-thread-resolve-checkbox.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     3.0.0
 */
?>

<script type="text/template" id="tmpl-ph-resolve-check">
	<i class="ph-icon ph-loading"></i>
	<# if (!data.resolved ) { #>
		<i class="ph-icon checkbox ion-android-checkbox-outline-blank"></i>
	<# } else { #>
		<i class="ph-icon checkbox ion-android-checkbox ph-approved"></i>
	<# } #>
</script>