<?php
/**
 * The Template for displaying the website thread container in the admin
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/admin/website/website-thread.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     3.0.0
 */
?>

<!-- Comment Box Template -->
<script type="text/template" id="tmpl-website-thread">
	<div class="todo-item ph-sort-handle <# if ( data.showInfo ) { print( 'opened' ); } #>">
		<div class="checkbox-wrap"></div>
		<div class="checkbox-text">
			<div class="ph-checkbox-header">
				<div class="ph-info ph-show-info">
					<div class="ph-comment-author">
						{{ data.author_name }}
					</div>
					<div class="ph-comment-date">
						{{ data.humanDate }}
					</div>
				</div>
				<div class="ph-webpage-controls-wrap"></div>
			</div>

			<div class="ph-comment-content"></div>
			<a href="#" class="ph-more ph-hidden">More</a>
			<a href="#" class="ph-less ph-hidden">Less</a>

		</div>
	</div>
	<div class="ph-task-info ph-hidden"></div>
</script>