<!-- assign dropdown -->
<script type="text/html" id="tmpl-ph-assign-dropdown">
    <# if ( data.assigned_model.get('id') ) {  #>
    <div class="ph-tooltip-wrap bottom ph-assigned ph-show-info">
        <# if ( data.assigned_model.get('avatar_urls') ) { #>
        <img src="{{{ data.assigned_model.get('avatar_urls')[96] }}}" class="avatar" />
        <# } else { #>
        <div class="ph-assign-user ph-unassigned">
            <i class="icon-plus">
                <svg xmlns="http://www.w3.org/2000/svg" width="8" height="8" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-plus"><line x1="12" y1="5" x2="12" y2="19"></line><line x1="5" y1="12" x2="19" y2="12"></line></svg>
            </i>
        </div>
        <# } #>
        <div class="ph-tooltip">
            <span class="ph-subtle"><?php _e( 'Assigned to', 'project-huddle' ); ?></span><br>{{ data.assigned_model.get('name') }}
        </div>
        <i class="icon-chevron-down">
            <svg xmlns="http://www.w3.org/2000/svg" width="10" height="10" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-chevron-down"><polyline points="6 9 12 15 18 9"></polyline></svg>
        </i>
    </div>
    <# } else { #>
    <div class="ph-tooltip-wrap bottom">
        <div class="ph-assign-user ph-unassigned">
            <i class="ion-plus">
                <svg xmlns="http://www.w3.org/2000/svg" width="10" height="10" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-plus"><line x1="12" y1="5" x2="12" y2="19"></line><line x1="5" y1="12" x2="19" y2="12"></line></svg>
            </i>
        </div>
        <i class="icon-chevron-down">
            <svg xmlns="http://www.w3.org/2000/svg" width="10" height="10" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-chevron-down"><polyline points="6 9 12 15 18 9"></polyline></svg>
        </i>
        <div class="ph-tooltip">
            <?php _e( 'Assign Someone', 'project-huddle' ); ?>
        </div>
    </div>
    <# } #>
    <div class="ph-assign-options"></div>
</script>
<!-- assign dropdown -->