<?php
/**
 * Template for the individual project image thumbnail
 *
 * @package     ProjectHuddle
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */

?>

<!-- Comment Item Template -->
<script type="text/template" id="tmpl-project-comment-item">
	<div class="ph-avatar"></div>

	<div class="ph-item-controls"></div>

	<div class="ph-comment-wrap">
		<div class="ph-comment-item-author">
			{{ data.author_name }}
		</div>

		<div class="ph-comment-item-date">
			{{ data.humanDate }}
		</div>
		<div class="ph-comment-item-text"></div>
		<div class="ph-edit-textarea"></div>

		<?php do_action( 'ph_comment_item_after_text', get_the_ID() ); ?>
	</div>
</script>
<!-- Comment Item Template -->
