<?php
/**
 * Template for the copy link dialog popup
 *
 * @package     ProjectHuddle
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */
?>

<!-- Copy Link Dialog Template -->
<script type="text/template" id="tmpl-dialog-copy-link">
	<form class="vex-dialog-form">

		<div class="vex-dialog-message">
			<?php echo apply_filters( 'ph_copy_link_dialog_message', __( 'Copy the link url.', 'project-huddle' ) ); ?>
		</div>

		<div class="vex-dialog-input">

			<?php do_action( 'ph_before_copy_link_dialog_inputs' ); ?>

			<textarea id="ph-copy-link" class="ph-copy-link">{{ data.link }}</textarea>

			<?php do_action( 'ph_after_copy_link_dialog_inputs' ); ?>

		</div>

	</form>
</script>
<!-- Copy Link Dialog Template -->