<script type="text/template" id='tmpl-ph-popup-reset'>
	<div class="ph-popup-container">
		<div class="ph-popup">
			<div class="ph-dialog-message">
				<?php _e('Enter your username or email address.', 'projecthuddle'); ?>
			</div>
			<p class="ph-text-muted"><?php _e( 'You will receive a link to create a new password via email.', 'project-huddle'); ?></p>
			<form>
				<div class="ph-dialog-input">
					<input type="text" id="ph-register-username-email" placeholder="Email or Username" required/>
				</div>
				<div class="ph-dialog-buttons">
					<button type="submit" class="ph-button">
						<?php _e('Done', 'project-huddle'); ?>
					</button>
					<button type="button" class="ph-secondary-link ph-close">
						<?php _e('Cancel', 'project-huddle'); ?>
					</button>
					<button type="button" class="ph-dialog-register ph-secondary-link">
						<?php _e('Register', 'project-huddle'); ?>
					</button>
				</div>
			</form>

            <div class="ph-close ph-close-icon">
                <svg viewBox="0 0 512 512" width="35" height="35">
                    <path class="amfst0" d="M340.2 160l-84.4 84.3-84-83.9-11.8 11.8 84 83.8-84 83.9 11.8 11.7 84-83.8 84.4 84.2 11.8-11.7-84.4-84.3 84.4-84.2z"></path>
                </svg>
            </div>

			<div class="ph-loading-image light"><div class="ph-loading-image-dots"></div></div>

			<div class="ph-success-message">
				<div class="ph-success-message-text">
					<strong><?php _e('Sent!', 'project-huddle'); ?></strong><br>
					<?php _e('Please check your inbox to set your password.', 'project-huddle'); ?>
				</div>
			</div>
		</div>
	</div>
</script>