<?php
/**
 * Approve Button Template
 *
 * @package     ProjectHuddle
 * @subpackage  Image Approvals
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.1.1
 */
?>

<!-- Controls Template -->
<script type="text/template" id="tmpl-approve-button">
    <button class="ph-approve-button ph-approve-image <# if (data.approval ) { #>ph-approved<# } else { #>ph-pending<# } #>">
        <span class="ph-button-text">
            <# if ( data.approval ) { #>
                <?php _e( 'Unapprove', 'project-huddle' ); ?>
            <# } else { #>
                <?php _e( 'Approve', 'project-huddle' ); ?>
            <# } #>
        </span>
    </button>
</script>