<script type="text/template" id="tmpl-image-filter">
	<h4 class="image-filter-dropdown">
		<# if (data.filter == 'unapproved') { #>
			<?php _e( 'UnApproved', 'project-huddle' ); ?>
		<# } else if ( data.filter == 'approved' ) { #>
			<?php _e( 'Approved', 'project-huddle' ); ?>
		<# } else { #>
			<?php _e( 'All Images', 'project-huddle' ); ?>
		<# } #><i class="ion-chevron-down"></i></h4>
	<div class="image-filter-menu-wrap">
		<ul class="image-filter-menu">
			<li data-sort="approved" class="<# if (data.filter== 'approved') { print('active'); } #>"><?php _e( 'Approved', 'project-huddle' ); ?></li>
			<li data-sort="unapproved" class="<# if (data.filter== 'unapproved') { print('active'); } #>"><?php _e( 'Unapproved', 'project-huddle' ); ?></li>
			<li data-sort="all" class="<# if (data.filter== 'all') { print('active'); } #>"><?php _e( 'All', 'project-huddle' ); ?></li>
		</ul>
	</div>
</script>

<script type="text/template" id="tmpl-no-images">
    <?php echo sanitize_text_field( sprintf( __( 'No %s Images', 'project-huddle' ), '{{ _(data.filter).capitalize() }}' ) ); ?>
</script>