<?php
/**
 * Template to show the project image collection
 *
 * @package     ProjectHuddle
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */
?>

<!-- Project Image Template -->
<script type="text/template" id="tmpl-project-image-collection">
	<header id="top-bar"></header>

    <div class="ph-side-panel"></div>
	<section id="canvas"></section>
	<div class="ph-loading"><div class="ph-loading-dots"></div></div>
    <div class="ph-footer"></div>

	<div class="ph-image-tip">
		<?php _e( 'Click to leave a comment.', 'project-huddle' ); ?>
	</div>
</script>
<!-- Project Image Template -->

<!-- Application data -->
<script>
	jQuery(document).ready(function(){
		ph.api.start(<?php echo json_encode( $project_data ); ?>);
	});
</script>