<?php
/**
 * Template for the individual project image thumbnail
 *
 * @package     ProjectHuddle
 * @copyright   Copyright (c) 2015, Andre Gagnon
 * @since       1.0
 */
?>

<script type="text/template" id="tmpl-project-image">
    <div class="ph-project-image-inner">
        <div class="ph-image-comments-container"></div>
<!--        <canvas class="ph-image-canvas"></canvas>-->
        <img class="ph-project-image" src="{{{data.url}}}" onload="jQuery(this).fadeIn();" />
        <div class="ph-image-controls"></div>
    </div>
</script>

<script type="text/template" id="tmpl-project-image-zoom">
    <div class="ph-project-zoom-wrap">
        <div class="ph-zoom-percent"><# print( Math.round(data.magnification * 100) ); #>%</div>
        <div class="ph-zoom-in">
            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-plus"><line x1="12" y1="5" x2="12" y2="19"></line><line x1="5" y1="12" x2="19" y2="12"></line></svg>
        </div>
        <div class="ph-zoom-out">
            <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-minus"><line x1="5" y1="12" x2="19" y2="12"></line></svg>
        </div>
    </div>
</script>

<script type="text/template" id="tmpl-image-zoom-controls">
    <div class="ph-zoom-in"><i class="ion-android-add-circle"></i></div>
    <div class="ph-zoom-out"><i class="ion-android-remove-circle"></i></div>
</script>

<script type="text/template" id="tmpl-image-zoom-percent">
    <# print( Math.round(data.magnification * 100) ); #>%
</script>