<?php
/**
 * The Template for displaying the website thread tech details.
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/thread/thread-tech-details.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     2.7.6
 */
?>

<script type="text/template" id="tmpl-ph-comment-tech-details">
    <div class="ph-dropdown-wrap ph-tech-detail-icon ph-right-dropdown ph-has-arrow ph-right-arrow ph-click-open">

        <div class="ph-tooltip-wrap bottom">
            <i class="ph-icon">
                <svg viewBox="0 0 512 512" id="ion-more" width="12" height="12"><path d="M113.7 304C86.2 304 64 282.6 64 256c0-26.5 22.2-48 49.7-48 27.6 0 49.8 21.5 49.8 48 0 26.6-22.2 48-49.8 48zM256 304c-27.5 0-49.8-21.4-49.8-48 0-26.5 22.3-48 49.8-48 27.5 0 49.7 21.5 49.7 48 0 26.6-22.2 48-49.7 48zM398.2 304c-27.5 0-49.8-21.4-49.8-48 0-26.5 22.2-48 49.8-48 27.5 0 49.8 21.5 49.8 48 0 26.6-22.2 48-49.8 48z"></path></svg>
            </i>

            <div class="ph-tooltip">
			    <?php _e( 'Details', 'project-huddle' ); ?>
            </div>
        </div>

        <div class="ph-dropdown">
            <div class="ph-dropdown-inner">
                <div class="ph-tech-item">
                    {{ data.browser }} {{ data.browserVersion }}
                </div>
                <div class="ph-tech-item">
                    {{ data.browserOS }}
                </div>
            </div>
        </div>
    </div>
</script>