<?php
/**
 * The Template for displaying the website thread header.
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/thread/thread-header.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     2.7.6
 */
?>

<script type="text/template" id="tmpl-project-comment-header">
    <?php do_action( 'ph_before_website_thread_header', get_the_ID() ); ?>

    <div class="ph-comment-header-left"></div>

    <div class="ph-comment-header-right"></div>

    <?php do_action( 'ph_after_website_thread_header', get_the_ID() ); ?>
</script>