<?php
/**
 * The Template for displaying the website thread share action
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/thread/thread-detail-delete.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see           https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author        Projecthuddle
 * @package       ProjectHuddle/Templates
 * @version       3.0.0
 */
?>

<script type="text/html" id="tmpl-ph-thread-share">
    <span class="ph-detail-icon">
		<i class="ph-icon ph-share-icon">
            <svg xmlns="http://www.w3.org/2000/svg" width="10" height="10" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-share-2"><circle cx="18" cy="5" r="3"></circle><circle cx="6" cy="12" r="3"></circle><circle cx="18" cy="19" r="3"></circle><line x1="8.59" y1="13.51" x2="15.42" y2="17.49"></line><line x1="15.41" y1="6.51" x2="8.59" y2="10.49"></line></svg>
		</i>
	</span>
	<?php _e( 'Share Comment', 'project-huddle' ); ?>
</script>