<?php
/**
 * The Template for displaying the website thread tech details.
 *
 * This template can be overridden by copying it to yourtheme/project-huddle/thread/thread-tech-details.tmpl.php.
 *
 * HOWEVER, on occasion ProjectHuddle will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.projecthuddle.io/article/15-overriding-templates-via-a-theme
 * @author 		Projecthuddle
 * @package 	ProjectHuddle/Templates
 * @version     2.7.6
 */
?>

<script type="text/template" id="tmpl-ph-comment-tech-details">
    <div class="ph-dropdown-wrap ph-tech-detail-icon ph-right-dropdown ph-has-arrow ph-right-arrow ph-click-open">

        <div class="ph-tooltip-wrap bottom">
            <i class="ph-icon">
                <svg xmlns="http://www.w3.org/2000/svg" width="12" height="12" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-more-horizontal"><circle cx="12" cy="12" r="1"></circle><circle cx="19" cy="12" r="1"></circle><circle cx="5" cy="12" r="1"></circle></svg>
            </i>

            <div class="ph-tooltip">
                <?php _e( 'Details', 'project-huddle' ); ?>
            </div>
        </div>

        <div class="ph-dropdown">
            <div class="ph-dropdown-inner">
                <div class="ph-tech-item">
                    {{ data.browser }} {{ data.browserVersion }}
                </div>
                <div class="ph-tech-item">
                    {{ data.browserOS }}
                </div>
            </div>
        </div>
    </div>
</script>